
#include <signal.h>
#include <stdio.h>

     void __C_runtime_error ( int trap_code, char *name, int line_no )
     {
       switch ( trap_code ) {
         /* Subscript range violations: */
         case BRK_RANGE:
           fprintf ( stderr, "error: Subscript range violation %s", name);
           break;

         /* Others (unknown trap codes): */
         default:
           fprintf ( stderr, "error: Trap %d ", trap_code );
           break;
       }

       fprintf ( stderr, " in '%s'", name);
       if ( line_no != -1 )
         fprintf ( stderr, " (line %d)", line_no );
       fprintf ( stderr, "0" );
       exit (99);
     }
