/// UT information for LFM-RCM hooks
struct RCMut {
  int startYear;    // Year to begin talking with RCM	  
  int startMonth;   //  Month to begin talking with RCM 
  int startDay;     //  Day to begin talking with RCM	  
  int startHour;    //  Hour to begin talking with RCM  
  int startMinute;  //  Minute to begin talking with RCM
  int startSecond;  //  Second to begin talking with RCM

  //  Interval between RCM exchanges in secs
  int deltaT;

  // Factor which determines what percentage of the RCM data should be
  // averaged into the LFM
  float bleed_rate;

  // In the OpenMP LFM, the user could select different averaging
  // (bleeding) schemes for LFM-RCM.  Each scheme was selected by an
  // integer "RCM_bleed_type_scheme".  The parallel code implements
  // just one scheme, but we're going to leave the parameter here in
  // case that changes down the road.
  //
  // This makes me think of "This page intentionally left blank"
  // http://www.joelonsoftware.com/items/2009/12/30.html
  int RCM_bleed_type_scheme; 
};
