      PROGRAM REGRID_OLD
c
c           *************************************************
c
c     program for a start-file for the parallel version of the MHD code
c
c        the magnetic field functions - AX, AY, and AZ must be defined externally
c
c           *************************************************
#include "param.inc"
c
c   make sure this is old-style param.inc
c
#include "dipole.inc"
#include "global_dims.inc"
#include "run-time.inc"
#include "regridded.inc"
      parameter (nion_i=njp1, nion_j=nk2p3)
      logical hdf_file, symmit
      integer hdfdump_var, hdfdump_first
      external AX,AY,AZ,Bxdip,bydip,bzdip
      dimension coor(nip1,njp1,nkp1,3)
	dimension divB(ni,nj,nk)
      dimension var(nip1,njp1,nkp1,14),
     $    bi(nip1,njp1,nkp1),bj(nip1,njp1,nkp1),bk(nip1,njp1,nkp1),
     $    x(nip1,njp1,nkp1),y(nip1,njp1,nkp1),z(nip1,njp1,nkp1),
     $     dum_e(nip1,njp1,nkp1)
      dimension c1ion(njp1,nk2p3,4)
      dimension varion(njp1,nkp1,3),varion1(nion_i,nion_j,12)
      dimension rho(nip1,njp1,nkp1),vx(nip1,njp1,nkp1),
     $     vy(nip1,njp1,nkp1),vz(nip1,njp1,nkp1)
      dimension c(nip1,njp1,nkp1),bx(nip1,njp1,nkp1),
     $     by(nip1,njp1,nkp1),bz(nip1,njp1,nkp1)
      dimension ei(nip1,njp1,nkp1),ej(nip1,njp1,nkp1),
     $   ek(nip1,njp1,nkp1)  
      equivalence
     $     (rho,var(1,1,1,1)),(vx,var(1,1,1,2)),(vy,var(1,1,1,3)),
     $     (vz,var(1,1,1,4)),(c,var(1,1,1,5)),(bx,var(1,1,1,6)),
     $     (by,var(1,1,1,7)),(bz,var(1,1,1,8)),(bi,var(1,1,1,9)),
     $     (bj,var(1,1,1,10)),(bk,var(1,1,1,11)),(ei,var(1,1,1,12)),
     $     (ej,var(1,1,1,13)),(ek,var(1,1,1,14))
      equivalence (x,coor(1,1,1,1)),(y,coor(1,1,1,2)),
     $     (z,coor(1,1,1,3))
c
c    ionospheric stuff
c
      dimension x2ion(njp1,nk2p3),y2ion(njp1,nk2p3)
      dimension x_interp(njp1,nk2p3),y_interp(njp1,nk2p3)
      dimension curnorth(njp1,nk2p3),cursouth(njp1,nk2p3)
      dimension psiNorth(njp1,nk2p3),psisouth(njp1,nk2p3),
     $	        sig_p_N(njp1,nk2p3),sig_h_N(njp1,nk2p3),
     $	        sig_p_S(njp1,nk2p3),sig_h_S(njp1,nk2p3)
      equivalence (c1ion,x2ion), (c1ion(1,1,2),y2ion)
      equivalence (c1ion(1,1,3),x_interp),(c1ion(1,1,4),y_interp)
      equivalence (varion1,psinorth),(varion1(1,1,2),psisouth)
      equivalence (varion1(1,1,3),curnorth),(varion1(1,1,4),cursouth)
      equivalence (varion1(1,1,5),sig_P_N),(varion1(1,1,6),sig_P_S)
      equivalence (varion1(1,1,7),sig_H_N),(varion1(1,1,8),sig_H_S)

      dimension x20(nip1,njp1),y20(nip1,njp1),phi0(nkp1)
     character*1 null
      pi =4.*atan(1.0)
      twopi = 2.*pi
      dr = 0.1
      ni_global = ni
      nj_global = nj
      nk_global = nk
      mion_i = njp1
      mion_j = nk2p3

      write (6,*) 'input hdffile (T/F), symmit (T/F), starting step'
      read (5,*) hdf_file, symmit, lstep
c
      if ( hdf_file ) then 
        ireturn = hdftake(.TRUE.,'TAKEHDF',lstep,time,
     $        imult, jmult, kmult,
     $                         var,coor,varion,varion1,c1ion,symmit)
      else
         ireturn = newstart(var,coor,varion,varion1,c1ion,symmit)
         lstep = 0
         time = 0.
      endif
c
c
c  these are dummy values, but it's nice to have nstart
c
      nstart = lstep
      nstop = nstart +10000
      ndump = 250
c
      do j=1,njp1
         do i=1,nip1
            x20(i,j) = x(i,j,1)
            y20(i,j) = sqrt(y(i,j,1)**2+z(i,j,1)**2)
         enddo
      enddo
      do k=1,nk
         phi0(k) = atan2(z(ni/2,nj/2,k),y(ni/2,nj/2,k))
         if ( phi0(k) .lt. 0. ) phi0(k) = phi0(k)+2.*pi
      enddo
         phi0(nkp1) = phi0(1) + 2.*pi
c
         ireturn = hdfdump_first(x20,y20,phi0)
         null = char(0)
         ireturn = hdfdump_var('X_'//null,x,
     $        nip1,njp1,nkp1,0,0.,.true.)
         ireturn = hdfdump_var('Y_'//null,y,
     $        nip1,njp1,nkp1,0,0.,.true.)
         ireturn = hdfdump_var('Z_'//null,z,
     $        nip1,njp1,nkp1,0,0.,.true.)
         ireturn = hdf_close()
c
         iStep = lstep
         ireturn = mhd_open_hdf(iStep, Time)
c
c   div B check
c
	do k=1,nk
	do j=1,nj
	do i=1,ni
	   Bfmax = max(abs(Bi(i,j,k)),abs(Bi(i+1,j,k)),
     $        abs(Bj(i,j,k)),abs(Bj(i,j+1,k)), 
     $         abs(Bk(i,j,k)),abs(Bk(i,j,k+1)))
	 divB(i,j,k) = (Bi(i+1,j,k)-Bi(i,j,k) +
     $                 Bj(i,j+1,k)-Bj(i,j,k)  +
     $                 Bk(i,j,k+1)-Bk(i,j,k))/(Bfmax + 1.e3)
	enddo
	enddo
	enddo
         null = char(0)
         ireturn = hdfdump_var('rho_'//null,var(1,1,1,1),
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('vx_'//null,var(1,1,1,2),
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('vy_'//null,var(1,1,1,3),
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('vz_'//null,var(1,1,1,4),
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('c_'//null,var(1,1,1,5),
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('bx_'//null,var(1,1,1,6),
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('by_'//null,var(1,1,1,7),
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('bz_'//null,var(1,1,1,8),
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('bi_'//null,bi,
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('bj_'//null,bj,
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('bk_'//null,bk,
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('ei_'//null,dum_e,
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('ej_'//null,dum_e,
     $        nip1,njp1,nkp1,0,0.,.false.)
         ireturn = hdfdump_var('ek_'//null,dum_e,
     $        nip1,njp1,nkp1,0,0.,.false.)
c
         ireturn = hdf_close()
c
c  ionospheric stuff
c
         ireturn = iondump_first(x2ion,y2ion,x_interp,y_interp)
         ireturn = hdf_close()
c
         ireturn = ion_open_hdf(istep,time)
         ireturn = ion2d_dump_var('currents'//null,current,njp1,nkp1,
     $                                              istep,time)
         ireturn = ion2d_dump_var('rho0'//null,rhoion,njp1,nkp1,
     $                                              istep,time)
         ireturn = ion2d_dump_var('c0'//null,cion,njp1,nkp1,
     $                                              istep,time)
         ireturn = ion2d_dump_var('curnorth'//null,curnorth,njp1,nk2p3,
     $                                              istep,time)
         ireturn = ion2d_dump_var('potnorth'//null,psinorth,njp1,nk2p3,
     $                                              istep,time)
         ireturn = ion2d_dump_var('SigmaH_north'//null,sig_h_N,
     $        njp1,nk2p3,istep,time)
         ireturn = ion2d_dump_var('SigmaP_north'//null,sig_p_N,
     $        njp1,nk2p3,istep,time)
         ireturn = ion2d_dump_var('fluxnorth'//null,flux_n,
     $        njp1,nk2p3,istep,time)
         ireturn = ion2d_dump_var('avE_north'//null,av_e_n,
     $        njp1,nk2p3,istep,time)
         ireturn = ion2d_dump_var('cursouth'//null,cursouth,njp1,nk2p3,
     $                                              istep,time)
         ireturn = ion2d_dump_var('potsouth'//null,psisouth,njp1,nk2p3,
     $                                              istep,time)
         ireturn = ion2d_dump_var('SigmaH_south'//null,sig_h_s,
     $        njp1,nk2p3,istep,time)
         ireturn = ion2d_dump_var('SigmaP_south'//null,sig_p_s,
     $        njp1,nk2p3,istep,time)
         ireturn = ion2d_dump_var('fluxsouth'//null,flux_s,
     $        njp1,nk2p3,istep,time)
         ireturn = ion2d_dump_var('avE_south'//null,av_e_s,
     $        njp1,nk2p3,istep,time)

         ireturn = hdf_close()
         
         
	end
c
c
c

      subroutine WRTGRID(X2a, Y2a, Phi0,x,y,z) 

c  This subroutine takes the X2,Y2, and Phi Arrays and constructs the 
c IJ, JK, and KI grid planes for restarting the T3D code


#include "param_global.inc"
      parameter (n1dg = nip1*njp1*nkp1)
      parameter (nipop1 = nip1+8)
      parameter (njpop1 = njp1+8)
      parameter (nkpop1 = nkp1+8)
      dimension rd(20)
c
      integer hdfdump_var, hdfdump_first
      character*1 null
      dimension x(nip1,njp1,nkp1),y(nip1,njp1,nkp1),z(nip1,njp1,nkp1)
      dimension x_g(n1dg), y_g(n1dg), z_g(n1dg)
      dimension x_g_old(n1dg), y_g_old(n1dg), z_g_old(n1dg)
      dimension phi(nkpop1),cphi(nkpop1),sphi(nkpop1)
      dimension theta(njpop1),ctheta(njpop1),stheta(njpop1)
      dimension r(nipop1)
      dimension x20(nip1,njp1),y20(nip1,njp1),r2(nip1,njp1)
      dimension x2a(nip1,njp1),y2a(nip1,njp1)
      dimension phi0(nkp1),x2(nipop1,njpop1),y2(nipop1,njpop1)
      dimension xs(n1dg),ys(n1dg),zs(n1dg)
      dimension bis(n1dg),bjs(n1dg),bks(n1dg)
      fijk(i,j,k,m) = float(i+100*j+10000*k+1000000*m)
c
      pi =4.*atan(1.0)
      twopi = 2.*pi
      dr = 0.1
#ifdef SHIFT
      dphi = 0.5*(phi0(2)-phi0(1))
      do k=1,nkp1
         phi0(k) = phi0(k) - dphi
      enddo
#endif
c
c
#ifdef REVERSE
c    reverse the grid
      do j=1,njp1
         do i=1,nip1
            x20(i,njp1+1-j) = -x2a(i,j)
            y20(i,njp1+1-j) = y2a(i,j)
         enddo
         enddo
#else
      do j=1,njp1
         do i=1,nip1
            x20(i,j) = x2a(i,j)
            y20(i,j) = y2a(i,j)
         enddo
         enddo
#endif
c
c  fix the pesky back axis
c
         small_axis = 1.e-6
        do i=1,nip1
           y20(i,njp1) = small_axis
           y20(i,1) = small_axis
        enddo
C
c  find mjin and mjwall 
          dxm = x20(nip1,2) - x20(nip1,1)
          dym = y20(nip1,2) - y20(nip1,1)
          dlen = sqrt(dxm**2 + dym**2)
          dxm = dxm/dlen
          dym = dym/dlen
          ncorns = 1
        do 22 j=2,nj
          dxp = x20(nip1,j+1) - x20(nip1,j)
          dyp = y20(nip1,j+1) - y20(nip1,j)
          dlen = sqrt(dxp**2 + dyp**2)
          dxp = dxp/dlen
          dyp = dyp/dlen
          if ( dyp .lt. 0.1 .and. ncorns .eq. 1 ) then
             mjin = j-1
             ncorns = 2
          else if ( dyp .lt. -0.5 .and. ncorns .eq. 2) then
             mjwall = j-1
             ncorns = 75
          endif
          dxm = dxp
          dym = dyp
 22     continue
c
c
        do j=1,njp1
        do i = 1,nip1
           x20(i,j) = x20(i,j)  !*rearth
           y20(i,j) = y20(i,j)  !*rearth
           enddo
           enddo
c
        DEGTORAD = ATAN(1.)/45.
        DO 88 K=1,NKP1
  88    PHI0(K) = PHI0(K)*DEGTORAD
       
        do k=1,nkp1
           cphi(k) = cos(phi0(k))
           sphi(k) = sin(phi0(k))
        enddo
C

        open(unit=97,file='boundgrid.dat',status='unknown')
 101    format(5e16.7)
        write (97,101) ((x20(i,j),i=1,nip1),j=1,njp1)
        write (97,101) ((y20(i,j),i=1,nip1),j=1,njp1)
        close(unit=97)
c
        
        do k=1,nkp1
           do j=1,njp1
              do i=1,nip1
                 x(i,j,k) = x20(i,j)
                 if ( abs(y20(i,j)) .le. 1.e-5*abs(x20(i,j)) ) then
                    y(i,j,k) = 1.e-9*abs(x20(i,j))*cphi(k)
                    z(i,j,k) = 1.e-9*abs(x20(i,j))*sphi(k)
                 else
                    y(i,j,k) = y20(i,j)*cphi(k)
                    z(i,j,k) = y20(i,j)*sphi(k)
                 endif
              enddo
           enddo
        enddo
c
c   start the HDF dump
c
        ireturn = hdfdump_first('STARTUP.hdf',11,x20,y20,phi0)

      null = char(0)
      ireturn = hdfdump_var('X_'//null,2,x,nip1,njp1,nkp1,0,0.,.true.)
      ireturn = hdfdump_var('Y_'//null,2,y,nip1,njp1,nkp1,0,0.,.true.)
      ireturn = hdfdump_var('Z_'//null,2,z,nip1,njp1,nkp1,0,0.,.true.)

c
      return
      end
c
	subroutine initmag(x,y,z,bi,bj,bk,mi,mj,mk,
     $     mip1,mjp1,mkp1)
#include "param_global.inc"
      parameter (nmag3d = nip1*njp1*nkp1)
      dimension x(mip1,mjp1,mkp1),y(mip1,mjp1,mkp1),
     $    z(mip1,mjp1,mkp1)
      dimension bi(mip1,mjp1,mkp1),bj(mip1,mjp1,mkp1),
     $     bk(mip1,mjp1,mkp1)
c
      dimension ai_0(nmag3d),aj_0(nmag3d),ak_0(nmag3d)
      pointer (paintqi,aintqi),(paintqj,aintqj),(paintqk,aintqk)
c
C     Integrate the magnetic vector potential around the edges
C     of each face.
c
      DIMENSION AINTqJ(MIp1,MJ,MKP1),AINTqK(MIP1,MJP1,MK),
     $     AINTqI(MI,MJP1,MKP1)
      EXTERNAL AX,AY,AZ
c
      paintqi = loc(ai_0)
      paintqj = loc(aj_0)
      paintqk = loc(ak_0)
C
c
        DO 300 K=1,MK
        DO 300 J=1,MJP1
        DO 300 I=1,MIP1
        AINTqK(I,J,K)=(X(I,J,K+1)-X(I,J,K))*GINT(Ax,X(I,J,K),Y(I,J,K),
     $          Z(I,J,K),X(I,J,K+1),Y(I,J,K+1),Z(I,J,K+1)) +
     $      (Y(I,J,K+1)-Y(I,J,K))*GINT(AY,X(I,J,K),Y(I,J,K),
     $          Z(I,J,K),X(I,J,K+1),Y(I,J,K+1),Z(I,J,K+1)) +
     $      (Z(I,J,K+1)-Z(I,J,K))*GINT(AZ,X(I,J,K),Y(I,J,K),
     $          Z(I,J,K),X(I,J,K+1),Y(I,J,K+1),Z(I,J,K+1))
  300   CONTINUE
        DO 310 K=1,MKP1
        DO 310 J=1,MJ
        DO 310 I=1,MIP1
  310   AINTqJ(I,J,K)=(X(I,J+1,K)-X(I,J,K))*GINT(Ax,X(I,J,K),Y(I,J,K),
     $          Z(I,J,K),X(I,J+1,K),Y(I,J+1,K),Z(I,J+1,K)) +
     $      (Y(I,J+1,K)-Y(I,J,K))*GINT(AY,X(I,J,K),Y(I,J,K),
     $          Z(I,J,K),X(I,J+1,K),Y(I,J+1,K),Z(I,J+1,K)) +
     $      (Z(I,J+1,K)-Z(I,J,K))*GINT(AZ,X(I,J,K),Y(I,J,K),
     $          Z(I,J,K),X(I,J+1,K),Y(I,J+1,K),Z(I,J+1,K))
        DO 320 K=1,MKP1
        DO 320 J=1,MJP1
        DO 320 I=1,MI
  320   AINTqI(I,J,K)=(X(I+1,J,K)-X(I,J,K))*GINT(Ax,X(I,J,K),Y(I,J,K),
     $          Z(I,J,K),X(I+1,J,K),Y(I+1,J,K),Z(I+1,J,K)) +
     $      (Y(I+1,J,K)-Y(I,J,K))*GINT(AY,X(I,J,K),Y(I,J,K),
     $          Z(I,J,K),X(I+1,J,K),Y(I+1,J,K),Z(I+1,J,K))+
     $      (Z(I+1,J,K)-Z(I,J,K))*GINT(AZ,X(I,J,K),Y(I,J,K),
     $          Z(I,J,K),X(I+1,J,K),Y(I+1,J,K),Z(I+1,J,K))
C
C     Now use Stokes theorem to compute the magnetic fluxes through
C     the faces from the line integrals of the vector potential.
        DO 340 K=1,MK
        DO 340 J=1,MJ
        DO 340 I=1,MIp1
  340   BI(I,J,K) = (AINTqJ(I,J,K) - AINTqJ(I,J,K+1) + AINTqK(I,J+1,K)
     $          - AINTqK(I,J,K))
C
        DO 350 K=1,MK
        DO 350 J=1,MJp1
        DO 350 I=1,MI
  350   BJ(I,J,K) =-( AINTqI(I,J,K) - AINTqI(I,J,K+1) + AINTqK(I+1,J,K)
     $          - AINTqK(I,J,K))
C
        DO 360 K=1,MKP1
        DO 360 J=1,MJ
        DO 360 I=1,MI
  360   BK(I,J,K) = ( AINTqI(I,J,K) - AINTqI(I,J+1,K) + AINTqJ(I+1,J,K)
     $          - AINTqJ(I,J,K))
C
        return
        end
C

      FUNCTION GINT(FX,X,Y,Z,X1,Y1,Z1)
      SAVE
C     Integrate FX(x,y,z) over the line (X,Y,Z) to (X1,Y1,Z1).
C     This subroutine does Gaussian integration with the first twelve
C     Legendre polynomials as the basis fuctions.
C     Abromowitz and Stegun page 916.
C     
      EXTERNAL FX
      DIMENSION WT(6),A(6)
C     The A() are the positive zeros of 12th order Legendre polynomial.
      DATA A/0.1252334085,  0.3678314989,  0.5873179542,
     $       0.7699026741,  0.9041172563,  0.9815606342/
C     Next are the Gaussian Integration coefficients for a
C     12th order polynomial. 
      DATA WT/0.2491470458,  0.2334925365,  0.2031674267,
     $        0.1600783285,  0.1069393259,  0.0471753363/
C
      DX = (X1-X)*0.5
      DY = (Y1-Y)*0.5
      DZ = (Z1-Z)*0.5
      XBAR = 0.5*(X+X1)
      YBAR = 0.5*(Y+Y1)
      ZBAR = 0.5*(Z+Z1)
C
      SUM = 0.
C
      DO 200 K=1,6
 200     SUM = SUM + WT(K)*(
     $        FX(XBAR+A(K)*DX,YBAR+A(K)*DY,ZBAR+A(K)*DZ) +
     $        FX(XBAR-A(K)*DX,YBAR-A(K)*DY,ZBAR-A(K)*DZ) )
C
      GINT = 0.5*SUM
C
      RETURN
      END
CC
      subroutine g2int(
     $       fbxcnt,fbycnt,fbzcnt,
     $     x0,x1,x2,x3,y0,y1,y2,y3,z0,z1,z2,z3,mi)
      SAVE
C     This subroutine does Gaussian integration of the function 
C
C     The Gaussian integration uses the first twelve Legendre polynomials
C     as the basis functions. Abromowitz and Stegun page 916.
#include "dipole.inc"
      parameter (nbig=1000)
#ifndef T3E
      double precision bx,by,bz,bsq
#endif
      real      fbxcnt(mi),fbycnt(mi),fbzcnt(mi)
      real WT(12),A(12)
      real x(nbig),y(nbig),z(nbig)
      real x0(mi),x1(mi),x2(mi),x3(mi)
      real y0(mi),y1(mi),y2(mi),y3(mi)
      real z0(mi),z1(mi),z2(mi),z3(mi)
      real xn(nbig),yn(nbig),zn(nbig)
      real dx(nbig,3),dy(nbig,3),dz(nbig,3)
      DATA A/0.1252334085,  0.3678314989,  0.5873179542,
     $     0.7699026741,  0.9041172563,  0.9815606342,
     $     -0.1252334085, -0.3678314989, -0.5873179542,
     $     -0.7699026741, -0.9041172563, -0.9815606342/
      DATA WT/0.2491470458,  0.2334925365,  0.2031674267,
     $     0.1600783285,  0.1069393259,  0.0471753363,
     $     0.2491470458, 0.2334925365, 0.2031674267,
     $     0.1600783285, 0.1069393259,  0.0471753363/
C
      if ( mi .gt. nbig ) then
         write (6,*) 'not enough tmp space in g2int, increase nbig to',
     $        ' at least ',mi
         stop
      endif
c
      do i=1,mi
      dx(i,1) = x1(i)-x0(i)
      dx(i,2) = x2(i)-x0(i)
      dx(i,3) = x3(i)+x0(i)-x2(i)-x1(i)
      dy(i,1) = y1(i)-y0(i)
      dy(i,2) = y2(i)-y0(i)
      dy(i,3) = y3(i)+y0(i)-y2(i)-y1(i)
      dz(i,1) = z1(i)-z0(i)
      dz(i,2) = z2(i)-z0(i)
      dz(i,3) = z3(i)+z0(i)-z2(i)-z1(i)
      enddo
C
      do i=1,mi
      fbxcnt(i) = 0.
      fbycnt(i) = 0.
      fbzcnt(i) = 0.
      enddo
C
#ifndef NOSUB     
      do 200 i=1,12
         do 200 j=1,12
            eta = 0.5*(1. + a(i))
            psi = 0.5*(1. + a(j))
C
            do k=1,mi
            x(k) = x0(k) + dx(k,1)*eta + dx(k,2)*psi + dx(k,3)*eta*psi
            y(k) = y0(k) + dy(k,1)*eta + dy(k,2)*psi + dy(k,3)*eta*psi
            z(k) = z0(k) + dz(k,1)*eta + dz(k,2)*psi + dz(k,3)*eta*psi
C
            xeta = dx(k,1) + dx(k,3)*psi
            yeta = dy(k,1) + dy(k,3)*psi
            zeta = dz(k,1) + dz(k,3)*psi
C     
            xpsi = dx(k,2) + dx(k,3)*eta
            ypsi = dy(k,2) + dy(k,3)*eta
            zpsi = dz(k,2) + dz(k,3)*eta
C
C  note the fancy footwork with 1.e10 to make the vaxvms version behave
C
            xn(k) = 1.e-10*(yeta*zpsi-zeta*ypsi)
            yn(k) = 1.e-10*(zeta*xpsi-xeta*zpsi)
            zn(k) = 1.e-10*(xeta*ypsi-xpsi*yeta)
c
c   hand code the dipole functions here to get speed
c
        rsq = x(k)**2 + y(k)**2 + z(k)**2
        adotr = dip_x*x(k) + dip_y*y(k) + dip_z*z(k)
        r = sqrt(rsq)
          bx = (geoqmu/rsq)*(dip_x-3.*x(k)*adotr/rsq)/r
          by = (geoqmu/rsq)*(dip_y-3.*y(k)*adotr/rsq)/r
          bz = (geoqmu/rsq)*(dip_z-3.*z(k)*adotr/rsq)/r
          pot = adotr*(geoqmu/rsq)/r
          bx = -1.0
          by = 0.
          bz = 0.
          pot = -x(k)
C
            bdotn = 2.5e9*(xn(k)*bx + yn(k)*by + zn(k)*bz)*
     $       wt(i)*wt(j)
            rnsq = xn(k)*xn(k)+yn(k)*yn(k)+zn(k)*zn(k)
            rn = sqrt(rnsq)
            area = 2.5e9*rn*wt(i)*wt(j)
            BSQ = (BX*BX+BY*BY+BZ*BZ)
            fbxcnt(k) = fbxcnt(k) + 2.5e9*wt(i)*wt(j)*xn(k)*pot
            fbycnt(k) = fbycnt(k) + 2.5e9*wt(i)*wt(j)*yn(k)*pot
            fbzcnt(k) = fbzcnt(k) + 2.5e9*wt(i)*wt(j)*zn(k)*pot
         enddo
C
  200   continue
C
c
C
#endif
C
        return
        end
C
      function area(x,y,z,x1,y1,z1)
c
#ifdef SMALL_RANGE
      data xlarge /1.e10/
      data xq /1.e-20/
      area = 0.5*xlarge*sqrt( (xq*(y*z1-z*y1))**2 + (xq*(z*x1-x*z1))**2
     $     +  (xq*(x*y1-y*x1))**2)
#else
      area = 0.5*sqrt( (y*z1-z*y1)**2 + (z*x1-x*z1)**2 +
     $     (x*y1-y*x1)**2)
#endif

      return
      end
c
      integer function newstart(var,coor,varion,varion2,c1ion)
c          *************************************************
#include "param.inc"
#include "dipole.inc"
#include "global_dims.inc"
#include "run-time.inc"
      parameter (nion_i=njp1, nion_j=nk2p3)
      logical hdf_file, symmit

      external AX,AY,AZ,Bxdip,bydip,bzdip
      pointer
     $     (prho,rho),(pvx,vx),(pvy,vy),
     $     (pvz,vz),(pc,c),(pbx,bx),
     $     (pby,by),(pbz,bz),(pbi,bi),
     $     (pbj,bj),(pbk,bk),(pei,ei),
     $     (pej,ej),(pek,ek)
      dimension coor(nip1,njp1,nkp1,3)
      dimension var(nip1,njp1,nkp1,11),
     $    bi(nip1,njp1,nkp1),bj(nip1,njp1,nkp1),bk(nip1,njp1,nkp1),
     $    x(nip1,njp1,nkp1),y(nip1,njp1,nkp1),z(nip1,njp1,nkp1),
     $     dum_e(nip1,njp1,nkp1)
      dimension c1ion(njp1,nk2p3,4)
      dimension varion(njp1,nkp1,3),varion2(nion_i,nion_j,12)
      dimension rho(nip1,njp1,nkp1),vx(nip1,njp1,nkp1),
     $     vy(nip1,njp1,nkp1),vz(nip1,njp1,nkp1)
      dimension c(nip1,njp1,nkp1),bx(nip1,njp1,nkp1),
     $     by(nip1,njp1,nkp1),bz(nip1,njp1,nkp1)
      dimension ei(nip1,njp1,nkp1),ej(nip1,njp1,nkp1),
     $   ek(nip1,njp1,nkp1)  

      dimension x20(nip1,njp1),y20(nip1,njp1),phi0(nkp1)
      character*1 null

      prho = loc(var(1,1,1,1))
      pvx = loc(var(1,1,1,2))
      pvy = loc(var(1,1,1,3))
      pvz = loc(var(1,1,1,4))
      pc = loc(var(1,1,1,5))
      pbx = loc(var(1,1,1,6))
      pby = loc(var(1,1,1,7))
      pbz = loc(var(1,1,1,8))
      pbi = loc(var(1,1,1,9))
      pbj = loc(var(1,1,1,10))
      pbk = loc(var(1,1,1,11))

      pi =4.*atan(1.0)
      twopi = 2.*pi
      dr = 0.1
      nstart = 0
      nstop = 0
      ndump = 1
      ni_global = ni
      nj_global = nj
      nk_global = nk
      rinner = 15.0*rearth
      router = 20.0*rearth
      rbar = 0.5*(rinner+router)
      del = 2.0/(router-rinner)
      a1 = -1.5*del
      b1 = -0.5*del**3
      rstop  = 25.*rearth
      geoqmu = 1.e7*rearth**3
      x_max = 22.0*rearth
      x_min = -185.0*rearth
      r_max = 80.*rearth
      sinner = 0.96
      souter = 1.05
      xq_off = 0.5*(x_max+x_min)
      bq = 1./r_max
      aq = 2./(x_max-x_min)
      dip_x = 0.0
      dip_y = 0.0
      dip_z = 1.0
      bx_zero = 0.
      bxq = bx_zero
      cos_tilt = 1.0
      sin_tilt = 0.01
      rho_0 = 1.0 !2.0e-25
      c_0 = 1.e5
      Vx_0 = 0.
      vy_0 = 0.
      vz_0 = 0.
      Bx_0 = 0.
      by_0 = 0.
      bz_0 = 0.
c
c
c   regular grid
        open(unit=82,file='GRIDOUT',status='old',form='formatted')
c
C
        READ(82,102) nshell,ntheta,mjin,mjwall
  102   format(4i6)
        write (6,*) ni,nj,nk
        write (6,*) nip1,njp1,nkp1
        IF ( NSHELL .EQ. NIP1 .AND. NTHETA .EQ. NJP1) GO TO 77
           WRITE (6,151)
           WRITE (9,151)
  151      FORMAT(1X,'NOT A PROPER DATA FILE FOR THE COOOBRDINATES')
#ifdef DOUBLEMESH
           if( (nshell-1)*2 +1 .eq. nip1 .and. 
     $          (ntheta-1)*2 +1 .eq. njp1 ) then
              close(82)
             
           endif
#endif
        stop
   77   CONTINUE
C
        READ(82,101) (PHI0(I),I=1,NKP1)
        READ(82,101) ((X20(I,J),I=1,NIP1),J=1,NJP1)
        READ(82,101) ((Y20(I,J),I=1,NIP1),J=1,NJP1)
  101   format(5e16.7)
        close(82)
c
#ifdef SPHERICAL
        pi = 4.*atan(1.0)
        do k=1,nkp1
           phi0(k) = 360.*float(k-1)/float(nk)
        enddo
        do i=1,nip1
           if ( i .le. 51 ) then
              r = 3.0 + float(i-1) ! /3.0
           else
              r = 3.0 + 20.0/3.0 +
     $          6.75/3.0*(exp(float(i-21)/6.75)-1.0)
           endif
           do j=1,njp1
              ang = float(j-1)/float(nj)*pi
              x20(i,j) = r*cos(ang)
              y20(i,j) = r*sin(ang)
           enddo
        enddo
#endif
c
	call wrtgrid(x20,y20,phi0,x,y,z)
        do k=1,nkp1
           do j=1,njp1
              do i=1,nip1
                 coor(i,j,k,1) = x(i,j,k)
                 coor(i,j,k,2) = y(i,j,k)
                 coor(i,j,k,3) = z(i,j,k)
              enddo
           enddo
        enddo
c
c
        do k=1,nk
	do j=1,nj
		do i=1,ni
	   var(i,j,k,1) = rho_0
           var(i,j,k,2) = vx_0
           var(i,j,k,3) = vy_0
           var(i,j,k,4) = vz_0
           var(i,j,k,5) = c_0
           var(i,j,k,6) = bx_0
           var(i,j,k,7) = by_0
           var(i,j,k,8) = bz_0
         enddo
         enddo
         enddo
c
         
         call initmag(x,y,z,bi,bj,bk,ni,nj,nk,nip1,njp1,nkp1)
c
c
c
         if ( symmit ) then
c   code to symmetrize the variables
c
         do l=1,8 
            c0 = 1.0
            c1 = 1.0
            c2 = 1.0
            c3 = 1.0
            if ( l .eq. 3 ) then
               c1 = -1.0
               c2 = -1.0
               c3 = 1.0
            elseif ( l .eq. 4 . or. l .eq. 6 ) then
               c1 = 1.0
               c2 = -1.0
               c3 = -1.0
            elseif ( l .eq. 7 ) then 
               c1 = -1.0
               c2 = 1.0
               c3 = -1.0
            else
               c1 = 1.0
               c2 = 1.0
               c3 = 1.0
            endif
         do k=1,nk/4
            do j = 1,nj
               do i=1,ni
            var_av = 0.25*(c0*var(i,j,k,l) + c1*var(i,j,nk/2+1-k,l)+
     $         c2*var(i,j,nk/2+k,l) + c3*var(i,j,nkp1-k,l))
            var(i,j,k,l) = var_av
            var(i,j,nk/2+1-k,l) = c1*var_av
            var(i,j,nkp1-k,l) = c3*var_av
            var(i,j,nk/2+k,l) = c2*var_av
               enddo
            enddo
         enddo
         enddo
c
            c0 = 1.0
            c1 = 1.0
            c2 = -1.0
            c3 = -1.0
         do k=1,nk/4
            do j = 1,nj
               do i=1,nip1
            bi_av = 0.25*(c0*bi(i,j,k) + c1*bi(i,j,nk/2+1-k)+
     $         c2*bi(i,j,nk2+k) + c3*bi(i,j,nkp1-k))
            bi(i,j,k) = bi_av
            bi(i,j,nk/2+1-k) = c1*bi_av
            bi(i,j,nkp1-k) = c3*bi_av
            bi(i,j,nk/2+k) = c2*bi_av
               enddo
            enddo
         enddo
c
            c0 = 1.0
            c1 = 1.0
            c2 = -1.0
            c3 = -1.0
         do k=1,nk/4
            do j = 1,njp1
               do i=1,ni
            bj_av = 0.25*(c0*bj(i,j,k) + c1*bj(i,j,nk/2+1-k)+
     $         c2*bj(i,j,nk2+k) + c3*bj(i,j,nkp1-k))
            bj(i,j,k) = bj_av
            bj(i,j,nk/2+1-k) = c1*bj_av
            bj(i,j,nkp1-k) = c3*bj_av
            bj(i,j,nk/2+k) = c2*bj_av
               enddo
            enddo
         enddo
c
            c0 = 1.0
            c1 = -1.0
            c2 = -1.0
            c3 = 1.0
         do k=1,nk/4+1
            do j = 1,nj
               do i=1,ni
            bk_av = 0.25*(c0*bk(i,j,k) + c1*bk(i,j,nk/2+2-k)+
     $         c2*bk(i,j,nk2+k) + c3*bk(i,j,nkp2-k))
            bk(i,j,k) = bk_av
            bk(i,j,nk/2+2-k) = c1*bk_av
            bk(i,j,nkp2-k) = c3*bk_av
            bk(i,j,nk/2+k) = c2*bk_av
               enddo
            enddo
         enddo  
         write (6,*) 'at the end of the calculation'

         endif
c
c
         do k=1,nkp1
            do j=1,njp1
               do i=1,nip1
                  dum_e(i,j,k) = 0.
                  bx(i,j,k) = bxdip(x(i,j,k),y(i,j,k),z(i,j,k))
                  by(i,j,k) = bydip(x(i,j,k),y(i,j,k),z(i,j,k))
                  bz(i,j,k) = bzdip(x(i,j,k),y(i,j,k),z(i,j,k))
               enddo
            enddo
         enddo
c
c   ionospheric stuff
c
c    this is all initialized in the code, so we don't really need it for a restart. the potential would be
c     nice, but hopefully the solver will converge without it
c
         do l=1,3
            do k=1,nkp1
               do j=1,njp1
                  varion(j,k,l) = 0.
               enddo
            enddo
         enddo
         do l=1,12
            do k=1,nkp1
               do j=1,njp1
                  varion2(j,k,l) = 0.
               enddo
            enddo
         enddo
         do l=1,4
            do k=1,nkp1
               do j=1,njp1
                  c1ion(j,k,l) = 0.
               enddo
            enddo
         enddo

         newstart =1
         return
         end


