C
c  functions to subtract from dipole
C
        function bxqq0(x,y,z)
#include "dipole.inc"
c
        rsq = x**2 + y**2 + z**2
        r = sqrt(rsq)
        if ( r .le. rinner ) then
          bxqq0 = -(geoqmu/rsq)*(3.*x*z/rsq)/r
        else if ( r .ge. router ) then
          bxqq0 = 0.
        else
          rprim = amax1(rinner,amin1(router,r))
          bxqq0 = -(geoqmu/rsq)*(3.*x*z/rsq)/r*(a1 + b1*rprim)
        endif
        return
        end
C
C
        function byqq0(x,y,z)
#include "dipole.inc"
c
        rsq = x**2 + y**2 + z**2
        r = sqrt(rsq)
        if ( r .le. rinner ) then
          byqq0 = -(geoqmu/rsq)*(3.*y*z/rsq)/r
        else if ( r .ge. router ) then
          byqq0 = 0.
        else
          rprim = amax1(rinner,amin1(router,r))
          byqq0 = -(geoqmu/rsq)*(3.*y*z/rsq)/r*(a1 + b1*rprim)
        endif
        return
        end
C     
C     
      function bzqq0(x,y,z)
#include "dipole.inc"
c
      rsq = x**2 + y**2 + z**2
      r = sqrt(rsq)
      if ( r .le. rinner ) then
         bzqq0 = -(geoqmu/rsq)*((2. - 3.*(x**2+y**2)/rsq)/r)
      else if ( r .ge. router ) then
         bzqq0 = 0.
      else
         rprim = amax1(rinner,amin1(router,r))
         bzqq0 = -(geoqmu/rsq)*(2.-3.*(x**2+y**2)/rsq)
     $        /(r)*(a1 + b1*rprim)
      endif
C     
      return
      end
c
c   vector potentials for initial load
c
        function ax(x,y,z)
#include "dipole.inc"
c
        r = sqrt(x**2+y**2+z**2)
        s = sqrt( ((x-xq_off)*aq)**2 + (y**2+z**2)*bq**2)
        if ( s .lt. sinner) then
          AX = (geoqmu/r**2)*(y/r)
        elseif ( s .lt. 1.0) then
          AX = (geoqmu/r**2)*(y/r)*(1.-s)/(1.-sinner)
        else
           AX = 0.
        endif
        return
        end
C
C
        function ay(x,y,z)
#include "dipole.inc"
c
        r = sqrt(x**2+y**2+z**2)
        s = sqrt( ((x-xq_off)*aq)**2 + (y**2+z**2)*bq**2)
        if ( s .lt. sinner) then
          AY = -(geoqmu/r**2)*(x/r)
        elseif ( s .lt. 1.0) then
          AY = -(geoqmu/r**2)*(x/r)*(1.-s)/(1.-sinner)
        elseif ( s .lt. souter ) then
          AY = -Bxq*(z*cos_tilt-x*sin_tilt)*(s-1.0)/(souter-1.0)
        else
          AY = -Bxq*(z*cos_tilt-x*sin_tilt)
        endif
        return
        end
C
      function az(x,y,z)
#include "dipole.inc"
c
c      for N-S dipoles this is set to zero, otherwise all 3 Vec pots neeed to include
c       dipole direction vector
c
      az = 0.
      return
      end
c
c
        function bxDIP(x,y,z)
#include "dipole.inc"
c
        rsq = x**2 + y**2 + z**2
        r = sqrt(rsq)
          bxDIP = -(geoqmu/rsq)*(3.*x*z/rsq)/r
        return
        end
C
C
        function byDIP(x,y,z)
#include "dipole.inc"
c
        rsq = x**2 + y**2 + z**2
        r = sqrt(rsq)
          byDIP = -(geoqmu/rsq)*(3.*y*z/rsq)/r
        return
        end
C
C
        real*4 function bzDIP(x,y,z)
#include "dipole.inc"
C
        rsq = x**2 + y**2 + z**2
        r = sqrt(rsq)
          bzDIP = -(geoqmu/rsq)*((2. - 3.*(x**2+y**2)/rsq)/r)
        return
        end


        function axdip(x,y,z)
#include "dipole.inc"
c
        r = sqrt(x**2+y**2+z**2)
          AXdip = (geoqmu/r**2)*(y/r)
        return
        end
C
C
        function aydip(x,y,z)
#include "dipole.inc"
c
        r = sqrt(x**2+y**2+z**2)
          AYdip = -(geoqmu/r**2)*(x/r)
        return
        end
C
      function azdip(x,y,z)
#include "dipole.inc"
c
c      for N-S dipoles this is set to zero, otherwise all 3 Vec pots neeed to include
c       dipole direction vector
c
      az = 0.
      return
      end
c









