      INTEGER FUNCTION hdftake(first,fname,mstep,ttime,
     $     newvar,newcoor,varion1,varion2,coordion)
c 
c This program reads HDF dump files from the Clock Dial simulation.
c


c df.inc


      integer DFOPEN,DFCLOSE,DFPUT,DFIOPEN
      integer DFERRNO
      integer DSSDIMS,DSPDATA,DSADATA
      integer DSGDIMS,DSGDATA
      parameter (nvar=14)
c param.inc
c  make sure this param.inc is old code (single processor) param.inc
c
#include "param.inc"
c var.inc
#include "var.inc"
#include "meter.inc"
#include "bzero.inc"
#include "boundx.inc"
#include "iongeo.inc"
#include "dipole.inc"
c
c	mjin = the number of inflowing j-faces.
c       mjinp1 = the j-value of the front corner?
c	mjwall = the j-value of the rear corner?
c

c
      integer ishape(3),idims(4)
      logical first,intfirst
      character*80 fname
      parameter(lentext=80)
      character*(lentext) text
	real newvar(nip1,njp1,nkp1,nvar),newcoor(nip1,njp1,nkp1,3)
        dimension varion1(njp1,nkp1,3),varion2(njp1,nk2p3,12)
        dimension coordion(njp1,nk2p3,4)
        dimension eoldi(ni,2)
c
      hdftake = 0 ! no error
	leng = len(fname)
      if (first) intfirst=.true.
      if (first .or. mstep .le. lstep ) then
c
         ierr = DFCLOSE(ifile)
	print *,'hdf file closed'
c

c
      print *, ' Read in the WIND data: mjin,mjwall '
c     set the boundx.inc parameters originally from MESH().
      nshell = nip1 ! nip1 ?
      ntheta = njp1 ! njp1 ?
      nangle = nkp1
      mjin   = 4    ! number of j-faces in the front?
      mjwall = 11 ! back corner ?
c
      print *,' len(fname),fname =',len(fname),fname
c      ifile = DFOPEN(fname,1,-1)
      ifile = DFIOPEN(fname,1,-1,len(fname))
c      write(6,*) ' DFIOPEN = ',ifile
      if( ifile .eq. 0 ) then
c         write(6,*) ' DFerror = ',DFERRNO()
      else
c
         itag = 17000           ! must be 16000-32000
         iref = 1

         ierr = DFGET(ifile,itag,iref,text(1:lentext),lentext)

         write(6,*) ' DFGET = ',ierr
         if( ierr .ne. 0 ) then
c            write(6,*) ' DFerror = ',DFERRNO()
         else
            print *,'text=<',text,'>'
c            read(text,'(5I8)') nshell,ntheta,nangle,mjin,mjwall
c            print *,' nshell,ntheta,nangle,mjin,mjwall=',
c    $           nshell,ntheta,nangle,mjin,mjwall
         endif
c     
         ierr = DFCLOSE(ifile)
         write(6,*) ' DFCLOSE = ',ierr
         if( ierr .ne. 0 ) then
            write(6,*) ' DFerror = ',DFERRNO()
         endif
      endif
c
c
c     Read in the Earth's magnetic dipole field data: "bzero.inc" 
      print *, ' Read in the magnetic dipole field data: "bzero.inc"'
      ierr = DSGDIMS(fname,irank,ishape,3) ! DFSDgetdims()
      if( ierr .ne. 0 ) then
         print *,' DFSDgetdims() = ',ierr
         print *,' DFerror = ',DFERRNO()
         hdftake = -1 ! Can not find a data set.
         return
      endif
      if( ishape(1) .ne. nbtot ) then
         print *,' Incompatible nbtot,ishape(1)=',nbtot,ishape(1)

         stop

      endif
      ierr = DSGDATA(fname,irank,ishape,bzeros) ! DFSDgetdata()
      if( ierr .ne. 0 ) then
         print *,' DFSDgetdata(BZEROS) = ',ierr
         print *,' DFerror = ',DFERRNO()
         stop
      endif
c      iref = DFSDlastref() ! DFSDlastref()
c      write(6,*) ' DFSDlastref(BZEROS) = ',iref
c      ierr = DAPLAB(fname,700,iref,'BZERO') ! DFANputlabel
c      write(6,*) ' DFANputlabel(BZEROS) = ',ierr
c      ierr = DAPDESC(fname,700,iref,'BZERO') ! DFANputdesc
c      write(6,*) ' DFANputdesc(BZEROS) = ',ierr
c
c
c     Write the mesh metric data: "meter.inc" 
      print *, ' Read in the mesh metric data: "meter.inc"'
      ierr = DSGDIMS(fname,irank,ishape,3) ! DFSDsetdims()
      if( ierr .ne. 0 ) then
         print *,' DFSDgetdims() = ',ierr
         print *,' DFerror = ',DFERRNO()
         stop
      endif
      if( ishape(1) .ne. n2dread ) then
         print *,' Incompatible n2dread,ishape(1)=',n2dread,ishape(1)

         stop

      endif
      ierr = DSGDATA(fname,irank,ishape,read2d) ! DFSDgetdata()
      if( ierr .ne. 0 ) then
         print *,' DFSDgetdata(READ2D) = ',ierr
         print *,' DFerror = ',DFERRNO()
         stop
      endif
c      iref = DFSDlastref() ! DFSDlastref()
c      write(6,*) ' DFSDlastref(READ2D) = ',iref
c      ierr = DAPLAB(fname,700,iref,'READ2D') ! DFANputlabel
c      write(6,*) ' DFANputlabel(READ2D) = ',ierr
c
c
c      ENDIF
c
c     Process var.inc
      number = 0
 707  continue
      print *, ' Read in the MHD state data: "var.inc"'
      varall(1) = real(lstep)
      ierr = DSGDIMS(fname,irank,ishape,3) ! DFSDsetdims()
      if( ierr .ne. 0 ) then
         print *,' DFSDgetdims() = ',ierr
         print *,' DFerror = ',DFERRNO()
         hdftake = -1 ! Can not find a data set.
         return
      endif
      if( ishape(1) .ne. nvarall ) then
         print *,' Incompatible nvarall,ishape(1)=',nvarall,ishape(1)
         if ( ishape(1) .eq. (nvar1+2) ) then
            write (6,*) ' appear just to be missing electric field data'
     $           ,', will continue'
         else

         stop
         endif
      endif
      ierr = DSGDATA(fname,irank,ishape,varall) ! DFSDgetdata()
      if( ierr .ne. 0 ) then
         print *,' DFSDgetdata(VARALL) = ',ierr
         print *,' DFerror = ',DFERRNO()
         stop
      endif
      lstep = int(varall(1))

	write (6,*) lstep
      number = number+1
      if ( mstep .gt. lstep .and. ierr .eq. 0 .and. number .lt. 500)
     $     go to 707
	write (6,*) rho(ni,1,1),rho(ni,nj,nk),vx(1,1,1),vx(ni,1,1)
	write (6,*) (x2(i,1),i=1,nip1)
c      iref = DFSDlastref() ! DFSDlastref()
c      write(6,*) ' DFSDlastref(VARALL) = ',iref
c      ierr = DAPLAB(fname,700,iref,'VARALL') ! DFANputlabel
c      write(6,*) ' DFANputlabel(VARALL) = ',ierr
c    do some setup
c
        if (first) then
           call metric
           call ionset
        endif
c
      ELSE
c
 717   continue
         do 703 i=1,ni
            eoldi(i,1) = etoti(i,1,1)
            eoldi(i,2) = etoti(i,nj,1)
 703        continue
c     Process var.inc
      print *, ' Read in the MHD state data: "var.inc"'
      varall(1) = real(lstep)
      ierr = DSGDIMS(fname,irank,ishape,3) ! DFSDsetdims()
      if( ierr .ne. 0 ) then
         print *,' DFSDgetdims() = ',ierr
         print *,' DFerror = ',DFERRNO()
         hdftake = -1 ! Can not find a data set.
         return
      endif
      if( ishape(1) .ne. nvarall ) then
         print *,' Incompatible nvarall,ishape(1)=',nvarall,ishape(1)
         if ( ishape(1) .eq. nvar1+2 ) then
            print *, 'Appear to be missing only E-field data,',
     $           ' will continue'
         else
            stop
         endif
      endif
      ierr = DSGDATA(fname,irank,ishape,varall) ! DFSDgetdata()
      if( ierr .ne. 0 ) then
         print *,' DFSDgetdata(VARALL) = ',ierr
         print *,' DFerror = ',DFERRNO()
         stop
      endif
      lstep = int(varall(1))

	write (6,*) lstep
      number = number+1
      if ( mstep .gt. lstep .and. ierr .eq. 0 .and. number .lt. 500)
     $     go to 717
	write (6,*) rho(ni,1,1),rho(ni,nj,nk),vx(1,1,1),vx(ni,1,1)
	write (6,*) (x2(i,1),i=1,nip1)
c      iref = DFSDlastref() ! DFSDlastref()
c      write(6,*) ' DFSDlastref(VARALL) = ',iref
c      ierr = DAPLAB(fname,700,iref,'VARALL') ! DFANputlabel
c      write(6,*) ' DFANputlabel(VARALL) = ',ierr
c
c
      ENDIF

      do l=1,14
         do k=1,nkp1
            do j=1,njp1
               do i=1,nip1
                  newvar(i,j,k,l) = 0.
               enddo
            enddo
         enddo
      enddo
c
c
      ttime = time
c
c   determine the dipole moment
c
      geoqmu = 1.0e24
      rinner = 500.0*6.38e8
      router = 1.5*rinner
      i = 1
      j=nj/2
      k = nk/4
           call g2int_dip(bnqfi_a,bsqqi_a,bxqfi_a,
     $          byqfi_a,bzqfi_a,bxqni_a,
     $          byqni_a,bzqni_a,faceqi(i,j,k),
     $          x(i,j,k),x(i,j+1,k),x(i,j,k+1),x(i,j+1,k+1),
     $          y(i,j,k),y(i,j+1,k),y(i,j,k+1),y(i,j+1,k+1),
     $          z(i,j,k),z(i,j+1,k),z(i,j,k+1),z(i,j+1,k+1))
       geoqmu = bnqfi(i,j,k)*geoqmu/bnqfi_a
       write (6,*) 'determined geoqmu as ', geoqmu
c
c
       do k=1,nkp1
          do j=1,nj
             do i=1,nip1

c
c    start writing the new data
c       1 - density units particles/cm^3
c	2,3,4 vx,vy,vz units kms
c	5 pressure kev/cm^3
c	6,7,8 Bx,By,Bz units of nanotesla
c	6,7,8 Ex,Ey,Ez units of V/m
c	6,7,8 Bx,By,Bz units of micro_A/m^2
c	9,10,11 x,y,z units of Re
c
	do  k=1,nk
	do  j=1,nj
	do  i=1,ni
           newvar(i,j,k,1) = rho(i,j,k)
           newvar(i,j,k,2) = vx(i,j,k)
           newvar(i,j,k,3) = vy(i,j,k)
           newvar(i,j,k,4) = vz(i,j,k)
           newvar(i,j,k,5) = c(i,j,k)
           newvar(i,j,k,6) = bx(i,j,k)
           newvar(i,j,k,7) = by(i,j,k)
           newvar(i,j,k,8) = bz(i,j,k)
        enddo
        enddo
        enddo
	do  k=1,nk
	do  j=1,nj
	do  i=1,nip1
           newvar(i,j,k,9) = bi(i,j,k)+bnqfi(i,j,k)*faceqi(i,j,k)
        enddo
        enddo
        enddo
	do  k=1,nk
	do  j=1,njp1
	do  i=1,ni
           newvar(i,j,k,10) = bj(i,j,k)+bnqfj(i,j,k)*faceqj(i,j,k)
        enddo
        enddo
        enddo
	do  k=1,nkp1
	do  j=1,nj
	do  i=1,ni
           newvar(i,j,k,11) = bk(i,j,k)+bnqfk(i,j,k)*faceqk(i,j,k)
        enddo
        enddo
        enddo
	do  k=1,nkp1
	do  j=1,njp1
	do  i=1,nip1
           newcoor(i,j,k,1) = x(i,j,k)
           newcoor(i,j,k,2) = y(i,j,k)
           newcoor(i,j,k,3) = z(i,j,k)
        enddo
        enddo
        enddo

	do  k=1,nk
	do  j=1,njp1
	do  i=1,nip1
           newvar(i,j,k,14) = etotk(i,j,k)
        enddo
        enddo
        enddo

	do  k=1,nkp1
	do  j=1,nj
	do  i=1,nip1
           newvar(i,j,k,13) = etotj(i,j,k)
        enddo
        enddo
        enddo

	do  k=1,nkp1
	do  j=1,njp1
	do  i=1,ni
           newvar(i,j,k,12) = etoti(i,j,k)
        enddo
        enddo
        enddo



        do l=1,12
           do k=1,nk2p3
              do j=1,njp1
                 varion2(j,k,l) = 0.
              enddo
           enddo
        enddo

        do l=1,3
           do k=1,nkp1
              do j=1,njp1
                 varion1(j,k,l) = 0.
              enddo
           enddo
        enddo
c
        do 900 k=1,nk2p3
        do 900 j=1,njp1
           varion2(j,k,1) = psinorth(j,k)
           varion2(j,k,2) = psisouth(j,k)
           varion2(j,k,3) = curnorth(j,k)
           varion2(j,k,4) = cursouth(j,k)
           varion2(j,k,5) = sig_p_n(j,k)
           varion2(j,k,6) = sig_p_s(j,k)
           varion2(j,k,7) = sig_h_n(j,k)
           varion2(j,k,8) = sig_h_s(j,k)
 900    continue
        do 901 k=1,nk2p3
        do 901 j=1,njp1
           coordion(j,k,1) = x2ion(j,k)
           coordion(j,k,2) = y2ion(j,k)
          coordion(j,k,3) = x2ion(j,k)
          coordion(j,k,4) = y2ion(j,k)
 901    continue
c
c
c
      RETURN
      END

c
        function triple(x,y,z)
        dimension x(3),y(3),z(3)
        dimension dum(3)
        call cross3(y,z,dum)
        triple = dot(x,dum)
        return
        end
c
c
        function dot(x,y)
        dimension x(3),y(3)
        dot = x(1)*y(1)+x(2)*y(2)+x(3)*y(3)
        return
        end
c
c
        subroutine cross3(x,y,z)
        dimension x(3),y(3),z(3)
        z(1) = x(2)*y(3) - x(3)*y(2)
        z(2) = x(3)*y(1) - x(1)*y(3)
        z(3) = X(1)*y(2) - x(2)*y(1)
        return
        end

      subroutine g2int_dip(fnorm,FPRESS,fx,fy,fz,fnx,fny,fnz,face,
     $     x0,x1,x2,x3,y0,y1,y2,y3,z0,z1,z2,z3)
      SAVE
C     This subroutine does Gaussian integration of the function 
C
C     The Gaussian integration uses the first twelve Legendre polynomials
C     as the basis functions. Abromowitz and Stegun page 916.
#ifndef T3E
      double precision bx,by,bz,bsq
#endif
      real dx(3),dy(3),dz(3)
      real WT(12),A(12)
      DATA A/0.1252334085,  0.3678314989,  0.5873179542,
     $     0.7699026741,  0.9041172563,  0.9815606342,
     $     -0.1252334085, -0.3678314989, -0.5873179542,
     $     -0.7699026741, -0.9041172563, -0.9815606342/
      DATA WT/0.2491470458,  0.2334925365,  0.2031674267,
     $     0.1600783285,  0.1069393259,  0.0471753363,
     $     0.2491470458, 0.2334925365, 0.2031674267,
     $     0.1600783285, 0.1069393259,  0.0471753363/
C
      dx(1) = x1-x0
      dx(2) = x2-x0
      dx(3) = x3+x0-x2-x1
      dy(1) = y1-y0
      dy(2) = y2-y0
      dy(3) = y3+y0-y2-y1
      dz(1) = z1-z0
      dz(2) = z2-z0
      dz(3) = z3+z0-z2-z1
C
      fnorm = 0.
      FPRESS = 0.
      fx = 0.
      fy = 0.
      fz = 0.
      fnx = 0.
      fny = 0.
      fnz = 0.
C     
      do 200 i=1,12
         do 200 j=1,12
            eta = 0.5*(1. + a(i))
            psi = 0.5*(1. + a(j))
C
            x = x0 + dx(1)*eta + dx(2)*psi + dx(3)*eta*psi
            y = y0 + dy(1)*eta + dy(2)*psi + dy(3)*eta*psi
            z = z0 + dz(1)*eta + dz(2)*psi + dz(3)*eta*psi
C
            xeta = dx(1) + dx(3)*psi
            yeta = dy(1) + dy(3)*psi
            zeta = dz(1) + dz(3)*psi
C     
            xpsi = dx(2) + dx(3)*eta
            ypsi = dy(2) + dy(3)*eta
            zpsi = dz(2) + dz(3)*eta
C
C  note the fancy footwork with 1.e10 to make the vaxvms version behave
C
            xn = 1.e-10*(yeta*zpsi-zeta*ypsi)
            yn = 1.e-10*(zeta*xpsi-xeta*zpsi)
            zn = 1.e-10*(xeta*ypsi-xpsi*yeta)
            bx = bxqq0(x,y,z)
            by = byqq0(x,y,z)
            bz = bzqq0(x,y,z)
C
            bdotn = 2.5e9*(xn*bx + yn*by + zn*bz)*wt(i)*wt(j)
            rnsq = xn*xn+yn*yn+zn*zn
            rn = sqrt(rnsq)
            area = 2.5e9*rn*wt(i)*wt(j)
            BSQ = (BX*BX+BY*BY+BZ*BZ)
            fnorm = fnorm + bdotn
            fpress = fpress + area*BSQ
            fx = fx + area*bx
            fy = fy + area*by
            fz = fz + area*bz
            fnx = fnx + bdotn*bx
            fny = fny + bdotn*by
            fnz = fnz + bdotn*bz
C
  200   continue
C
        fnx = fnx/(fnorm + 1.e-20)
        fny = fny/(fnorm + 1.e-20)
        fnz = fnz/(fnorm + 1.e-20)
        fnorm = fnorm/face
        fpress = fpress/face
        fx = fx/face
        fy = fy/face
        fz = fz/face
C
C
        return
        end
C
