      subroutine regrid(mi_0,mj_0,mk_0,mult_i,mult_j,mult_k)
#include "param.inc"
#include "var.inc"
#include "meter.inc"
#include "regridded.inc"
      real var_float
c
c
c
      mi_old = mi_0
      mj_old = mj_0
      mk_old = mk_0
      px_old = loc(x)
      py_old = loc(y)
      pz_old = loc(z)
      prho_old = loc(rho)
      pvx_old = loc(vx)
      pvy_old = loc(vy)
      pvz_old = loc(vz)
      pbx_old = loc(bx)
      pby_old = loc(by)
      pbz_old = loc(bz)
      pc_old = loc(c)
      pbi_old = loc(bi)
      pbj_old = loc(bj)
      pbk_old = loc(bk)
      px2_old = loc(x2)
      py2_old = loc(y2)
      pphi_old = loc(phi)
c
      if ( mult_i .gt. 1 ) then
         if (mult_i .gt. 4 ) then
            write (6,*) 'multiplier must be less-equal 4', multi_c
            stop
         endif
         mi = mult_i*mi_old
         mj = mj_old
         mk = mk_old
         mult_c = mult_i
         icoord = 1
c
         call var_shuffle(mi,mj,mk,mi_old,mj_old,mk_old)
c
         mi_old = mi
         mj_old = mj
         mk_old = mk
c         
      endif
      if ( mult_j .gt. 1 ) then
         if (mult_j .gt. 4 ) then
            write (6,*) 'multiplier must be less-equal 4', multi_j
            stop
         endif
         mi = mi_old
         mj = mult_j*mj_old
         mk = mk_old
         mult_c = mult_j
         icoord = 2
c
         call var_shuffle(mi,mj,mk,mi_old,mj_old,mk_old)
c
         mi_old = mi
         mj_old = mj
         mk_old = mk
c         
      endif
      if ( mult_k .gt. 1 ) then
         if (mult_k .gt. 4 ) then
            write (6,*) 'multiplier must be less-equal 4', multi_k
            stop
         endif
         mi = mi_old
         mj = mj_old
         mk = mult_k*mk_old
         mult_c = mult_k
         icoord = 3
c
         call var_shuffle(mi,mj,mk,mi_old,mj_old,mk_old)
c
         mi_old = mi
         mj_old = mj
         mk_old = mk
c         
      endif
c
**      write out the data
c

      return
       end
c
c
       subroutine var_shuffle(mi,mj,mk,mi_old,mj_old,mk_old)
#include "regridded.inc"
c
c
      prho_new = malloc(sizeof(var_float)*mi*mj*mk)
      px_new = malloc(sizeof(var_float)*(mi+1)*(mj+1)*(mk+1))
      py_new = malloc(sizeof(var_float)*(mi+1)*(mj+1)*(mk+1))
      pz_new = malloc(sizeof(var_float)*(mi+1)*(mj+1)*(mk+1))
      pvx_new = malloc(sizeof(var_float)*mi*mj*mk)
      pvy_new = malloc(sizeof(var_float)*mi*mj*mk)
      pvz_new = malloc(sizeof(var_float)*mi*mj*mk)
      pbx_new = malloc(sizeof(var_float)*mi*mj*mk)
      pby_new = malloc(sizeof(var_float)*mi*mj*mk)
      pbz_new = malloc(sizeof(var_float)*mi*mj*mk)
      pbi_new = malloc(sizeof(var_float)*(mi+1)*mj*mk)
      pbj_new = malloc(sizeof(var_float)*mi*(mj+1)*mk)
      pbk_new = malloc(sizeof(var_float)*mi*mj*(mk+1))
      pc_new = malloc(sizeof(var_float)*mi*mj*mk)
      px2_new = malloc(sizeof(var_float)*(mi+1)*(mj+1))
      py2_new = malloc(sizeof(var_float)*(mi+1)*(mj+1))
      pphi_new = malloc(sizeof(var_float)*(mk+1))
      px2d = malloc(sizeof(var_float)*(mi_old+3)*(mj_old+3))
      py2d = malloc(sizeof(var_float)*(mi_old+3)*(mj_old+3))
c
       call newVar(mi,mj,mk,mi_old,mj_old,mk_old)
c
       call free(px2d)
       call free(py2d)
c
      prho_old = prho_new
      px_old = px_new
      py_old = py_new
      pz_old = pz_new
      pvx_old = pvx_new
      pvy_old = pvy_new
      pvz_old = pvz_new
      pbx_old = pbx_new
      pby_old = pby_new
      pbz_old = pbz_new
      pbi_old = pbi_new
      pbj_old = pbj_new
      pbk_old = pbk_new
      pc_old = pc_new
      px2_old = px2_new
      py2_old = py2_new
      pphi_old = pphi_new
c
      call free(prho_new)
      call free(px_new)
      call free(py_new)
      call free(pz_new)
      call free(pvx_new)
      call free(pvy_new)
      call free(pvz_new)
      call free(pbx_new)
      call free(pby_new)
      call free(pbz_new)
      call free(pbi_new)
      call free(pbj_new)
      call free(pbk_new)
      call free(pc_new)
      call free(px2_new)
      call free(py2_new)
      call free(pphi_new)
c
      return
      end
c
       subroutine newVar(mi,mj,mk,mi_old,mj_old,mk_old)
#include "param.inc"
#include "boundx.inc"
#include "regridded.inc"
      character*80 filename
        dimension x_new(mi+1,mj+1,mk+1),y_new(mi+1,mj+1,mk+1),
     $    z_new(mi+1,mj+1,mk+1)
        dimension rho_new(mi,mj,mk),c_new(mi,mj,mk)
        dimension vx_new(mi,mj,mk),vy_new(mi,mj,mk),vz_new(mi,mj,mk)
        dimension bx_new(mi,mj,mk),by_new(mi,mj,mk),bz_new(mi,mj,mk)
        dimension bi_new(mi+1,mj,mk),bj_new(mi,mj+1,mk),
     $   bk_new(mi,mj,mk+1)
        dimension x_old(mi_old+1,mj_old+1,mk_Old+1),
     $       y_old(mi_old+1,mj_old+1,mk_Old+1),
     $    z_old(mi_old+1,mj_old+1,mk_Old+1)
        dimension rho_old(mi_old,mj_old,mk_Old),
     $       c_old(mi_old,mj_old,mk_Old)
        dimension vx_old(mi_old,mj_old,mk_Old),
     $       vy_old(mi_old,mj_old,mk_Old),vz_old(mi_old,mj_old,mk_Old)
        dimension bx_old(mi_old,mj_old,mk_Old),
     $       by_old(mi_old,mj_old,mk_Old),bz_old(mi_old,mj_old,mk_Old)
        dimension bi_old(mi_old+1,mj_old,mk_Old),
     $       bj_old(mi_old,mj_old+1,mk_Old),
     $   bk_old(mi_old,mj_old,mk_Old+1)
        dimension x(nip1,njp1,nkp1),y(nip1,njp1,nkp1),z(nip1,njp1,nkp1)
      dimension x2d(0:mi_old+2,0:mj_old+2),y2d(0:mi_old+2,0:mj_old+2),
     $       phid(mk_old+1),
     $          phi(mk_old+1) 
c
c

      pi = atan(1.0)*4.
      pi2 = 2.*pi
      
        do j=1,mj_old+1
           do i=1,mi_old+1
              x2d(i,j) = x_old(i,j,1)/rearth
              y2d(i,j) = sqrt(y_old(i,j,1)**2+z_old(i,j,1)**2)
     $             /rearth
           enddo
        enddo
        do j=1,mj_old+1
           x2d(0,j) = 1.5*x2d(1,j)-0.5*x2d(2,j)
           y2d(0,j) = 1.5*y2d(1,j)-0.5*y2d(2,j)
           x2d(mi_old+2,j) = 1.5*x2d(mi_old+1,j)-0.5*x2d(mi_old,j)
           y2d(mi_old+2,j) = 1.5*y2d(mi_old+1,j)-0.5*y2d(mi_old,j)
        enddo
        do i=0,mi_old+2
           x2d(i,0) = x2d(i,2)
           y2d(i,0) = -y2d(i,2)
           x2d(i,mj_old+2) = x2d(i,mj_old)
           y2d(i,mj_old+2) = -y2d(i,mj_old)
        enddo
        do k=1,mk_old+1
           phi(k) = atan2(z_old(5,3,k),y_old(5,3,k))
        enddo
        pi2 = 8.*atan(1.)
        rad2deg = 360./pi2
        do k=1,mk_old+1
           if (phi(k) .lt. 0.0 ) then
              phi(k) = phi(k)+pi2
           endif
           phid(k) = rad2deg*phi(k)
        enddo
c
c    make new GRIDOUT file
c
	call Newgrid(x2d,y2d,phid,mi,mj,mk,mjin,mjwall,
     $       mi_old,mj_old,mk_old)
c          
c   loop over the other sets
c
c   read in the variable data
cc
#ifdef GOVAR
      if ( icoord .eq. 1 ) then
         muli = mult_c
         mulj = 1
         mulk = 1
       else if ( icoord .eq. 2) then
         muli = 1
         mulj = mult_c
         mulk = 1
        else
           muli = 1
           mulj = 1
           mulk = mult_c
        endif
        do k=1,mk_old
        do kkq=1,mulk
         ks = mulk*(k-1)+kkq
         do j=1,mj_old
            do jj=1,mulj
               js = mulj*(j-1) + jj
            do i=1,mi_old
               do ii=1,muli
                 is = muli*(i-1) + ii
               rho_new(is,js,ks) = rho_old(i,j,k)
               vx_new(is,js,ks) = vx_old(i,j,k)
               vy_new(is,js,ks) = vy_old(i,j,k)
               vz_new(is,js,ks) = vz_old(i,j,k)
               c_new(is,js,ks) = c_old(i,j,k)
               bx_new(is,js,ks) = bx_old(i,j,k)
               by_new(is,js,ks) = by_old(i,j,k)
               bz_new(is,js,ks) = bz_old(i,j,k)
               bk_new(is,js,ks) = bk_old(i,j,k)
               bj_new(is,js,ks) = bj_old(i,j,k)
               bi_new(is,js,ks) = bi_old(i,j,k)
               enddo
            enddo
            enddo
         enddo
         do j=1,mj_old
            do jj=1,mulj
               js = mulj*(j-1) + jj
            i=mi_Old+1
               ii=1
                 is = muli*(i-1) + ii
               bi_new(is,js,ks) = bi_old(i,j,k)
            enddo
         enddo
          j=njp1
             jj=1
               js = mulj*(j-1) + jj
            do i=1,mi_old
               do ii=1,muli
                 is = muli*(i-1) + ii
               bj_new(is,js,ks) = bj_old(i,j,k)
               enddo
            enddo
       enddo
      enddo
         ks = mulk*nk + 1
         do j=1,mj_old
            do jj=1,mulj
               js = mulj*(j-1) + jj
            do i=1,mi_old
               do ii=1,muli
                 is = muli*(i-1) + ii
               bk_new(is,js,ks) = bk_old(i,j,mk+1)
               enddo
            enddo
            enddo
         enddo
c
*          call chkdiv(bi_new,bj_new,bk_new,mi,mj,mk)
c
c  fix up the magnetic field
c
         if ( icoord .eq. 1) then 
            do k=1,mk_old+1
            do j=1,mj_old+1
               do i=1,mi_old
                 istart = mult_c*(i-1) + 1
                 istop = istart + mult_c
                 db = bi_new(istop,j,k) - bi_new(istart,j,k)
                 do ii=2,mult_c
                   bi_new(istart+ii-1,j,k) = bi_new(istart,j,k) +
     $        db*float(ii-1)/float(mult_c)
                 enddo
               enddo
            enddo
            enddo
            do k=1,mk
               do j=1,mj+1
                  do i=1,mi
                     bj_new(i,j,k) = bj_new(i,j,k)/float(mult_c)
                  enddo
               enddo
            enddo
            do k=1,mk+1
               do j=1,mj
                  do i=1,mi
                     bk_new(i,j,k) = bk_new(i,j,k)/float(mult_c)
                  enddo
               enddo
            enddo
         else if ( icoord .eq. 2 ) then 
            do k=1,mk_old
               do i=1,mi_old
            do j=1,mj_old
                 jstart = mult_c*(j-1) + 1
                 jstop = jstart + mult_c
                 db = bj_new(i,jstop,k) - bj_new(i,jstart,k)
                 do jj=2,mult_c
                   bj_new(i,jstart+jj-1,k) = bj_new(i,jstart,k) +
     $        db*float(jj-1)/float(mult_c)
                 enddo
               enddo
            enddo
            enddo
            do k=1,mk
               do j=1,mj
                  do i=1,mi+1
                     bi_new(i,j,k) = bi_new(i,j,k)/float(mult_c)
                  enddo
               enddo
            enddo
            do k=1,mk+1
               do j=1,mj
                  do i=1,mi
                     bk_new(i,j,k) = bk_new(i,j,k)/float(mult_c)
                  enddo
               enddo
            enddo
          else
            do j=1,mj_old
               do i=1,mi_old
            do k=1,mk_old
                 kstart = mult_c*(k-1) + 1
                 kstop = kstart + mult_c
                 db = bk_new(i,j,kstop) - bk_new(i,j,kstart)
                 do kkq=2,mult_c
                   bk_new(i,j,kstart+kkq-1) = bk_new(i,j,kstart) +
     $        db*float(kkq-1)/float(mult_c)
                 enddo
               enddo
            enddo
            enddo
            do k=1,mk
               do j=1,mj+1
                  do i=1,mi
                     bj_new(i,j,k) = bj_new(i,j,k)/float(mult_c)
                  enddo
               enddo
            enddo
            do k=1,mk
               do j=1,mj
                  do i=1,mi+1
                     bi_new(i,j,k) = bi_new(i,j,k)/float(mult_c)
                  enddo
               enddo
            enddo
          endif
             
                    
c
          call chkdiv(bi_new,bj_new,bk_new,mi,mj,mk)
c
         open (unit=88,file='DUM_VAR',form='unformatted',
     $         status='unknown')
         write (88) time,lstep
         write (88) rho_new
         write (88) vx_new
         write (88) vy_new
         write (88) vz_new
         write (88) c_new
         write (88) bx_new
         write (88) by_new
         write (88) bz_new
         write (88) bi_new
         write (88) bj_new
         write (88) bk_new
c  
         close (88)
c
#endif
         call write_param(mi,mj,mk,no,npes,nmhdpes,ionpes)
c
         end
c
	subroutine newgrid(x,y,phi,mi,mj,mk,mjin,mjwall,
     $     mi_old,mj_old,mk_old)
#include "param.inc"
#include "regridded.inc"
	dimension x(0:mi_old+2,0:mj_old+2),y(0:mi_old+2,0:mj_old+2),
     $       phi(mk_old+1)
	dimension x2_new(mi+1,mj+1),y2_new(mi+1,mj+1),phi_new(mk+1)
        dimension x_new(mi+1,mj+1,mk+1),y_new(mi+1,mj+1,mk+1),
     $       z_new(mi+1,mj+1,mk+1)
        dimension phidum(0:1000)
c
c
        if ( icoord .eq. 1 ) then
           do j=1,mj_old+1
           do i=1,mi_old
              dx = x(i+1,j) - x(i,j)
              dx2 = x(i+2,j) - x(i-1,j)
              xb = 0.5*(x(i+1,j)+x(i,j))
              xb2 = 0.5*(x(i+2,j)+x(i-1,j))
              a = (9.*xb-xb2)/8.
              b = (27.*dx-dx2)/24.
              c = 0.5*(xb2-xb)
              d = (dx2-3.*dx)/6.
              do l=1,mult_c+1
                dd = -0.5 + (l-1)/float(mult_c)
                x2_new(mult_c*(i-1)+l,j) = a + b*dd + c*dd**2 + d*dd**3
              enddo
              dy = y(i+1,j) - y(i,j)
              dy2 = y(i+2,j) - y(i-1,j)
              yb = 0.5*(y(i+1,j)+y(i,j))
              yb2 = 0.5*(y(i+2,j)+y(i-1,j))
              a = (9.*yb-yb2)/8.
              b = (27.*dy-dy2)/24.
              c = 0.5*(yb2-yb)
              d = (dy2-3.*dy)/6.
              do l=1,mult_c+1
                dd = -0.5 + (l-1)/float(mult_c)
                y2_new(mult_c*(i-1)+l,j) = a + b*dd + c*dd**2 + d*dd**3
              enddo
           enddo
           enddo
           do k=1,mk_old+1
             phi_new(k) = phi(k)
           enddo
           phi_new(1) = 0.
           phi_new(mk_old+1) = 360.0
         elseif ( icoord .eq. 2 ) then
           do j=1,mj_old
           do i=1,mi_old+1
              dx = x(i,j+1) - x(i,j)
              dx2 = x(i,j+2) - x(i,j-1)
              xb = 0.5*(x(i,j+1)+x(i,j))
              xb2 = 0.5*(x(i,j+2)+x(i,j-1))
              a = (9.*xb-xb2)/8.
              b = (27.*dx-dx2)/24.
              c = 0.5*(xb2-xb)
              d = (dx2-3.*dx)/6.
              do l=1,mult_c+1
                dd = -0.5 + (l-1)/float(mult_c)
                x2_new(i,(j-1)*mult_c+l) = a + b*dd + c*dd**2 + d*dd**3
                if ( i .eq. mi_old+1 ) then
                   x2_new(i,(j-1)*mult_c+l) =
     $                  xb + dx*dd
                endif
              enddo
              dy = y(i,j+1) - y(i,j)
              dy2 = y(i,j+2) - y(i,j-1)
              yb = 0.5*(y(i,j+1)+y(i,j))
              yb2 = 0.5*(y(i,j+2)+y(i,j-1))
              a = (9.*yb-yb2)/8.
              b = (27.*dy-dy2)/24.
              c = 0.5*(yb2-yb)
              d = (dy2-3.*dy)/6.
              do l=1,mult_c+1
                dd = -0.5 + (l-1)/float(mult_c)
                y2_new(i,(j-1)*mult_c+l) = a + b*dd + c*dd**2 + d*dd**3
                if ( i .eq. mi_old+1) then
                    y2_new(i,(j-1)*mult_c+l) = yb + dy*dd
                endif
              enddo
           enddo
           enddo
           do k=1,mk_old+1
             phi_new(k) = phi(k)
           enddo
           phi_new(1) = 0.
           phi_new(mk_old+1) = 360.0
           mjin_new = mult_c*mjin
           mjwall_new = mult_c*mjwall
         else
            do k=1,mk_old+1
               phidum(k) = phi(k)
            enddo
               phidum(1) = 0.
               phidum(mk_old+1) = 360.0
               phidum(0) = phi(mk_old) - 360.0
               phidum(mk_old+2) = phi(2) + 360.0
               phidum(mk_old+3) = phi(3) + 360.0
           do i=1,mk_old+1
              dx = phidum(i+1) - phidum(i)
              dx2 = phidum(i+2) - phidum(i-1)
              xb = 0.5*(phidum(i+1)+phidum(i))
              xb2 = 0.5*(phidum(i+2)+phidum(i-1))
              a = (9.*xb-xb2)/8.
              b = (27.*dx-dx2)/24.
              c = 0.5*(xb2-xb)
              d = (dx2-3.*dx)/6.
              do l=1,mult_c+1
                dd = -0.5 + (l-1)/float(mult_c)
                phi_new(mult_c*(i-1)+l) = a + b*dd + c*dd**2 + d*dd**3
              enddo
            enddo
              phi_new(1) = 0.
              phi_new(mk+1) = 360.
              do j=1,mj_old+1
              do i=1,mi_old+1
              	x2_new(i,j) = x(i,j)
              	y2_new(i,j) = y(i,j)
             enddo
             enddo
          endif
          deg2rad = atan(1.)/45.0
          do k=1,mk+1
             cpp = cos(phi_new(k)*deg2rad)
             spp = sin(phi_new(k)*deg2rad)
             do j=1,mj+1
                do i=1,mi+1
                   x_new(i,j,k) = x2_new(i,j)*rearth
                   y_new(i,j,k) = y2_new(i,j)*rearth*cpp
                   z_new(i,j,k) = y2_new(i,j)*rearth*spp
                enddo
             enddo
          enddo
c
c      write new gridout file
c 
          mjp1 = mj+1
          mip1 = mi+1
          mkp1 = mk+1
	   open(unit=44,file='NEW-GRIDOUT',form='formatted',
     $         status='unknown')
        write (44,102) mip1,mjp1,mjin_new,mjwall_new,mkp1
 102   format(5i6)
C
        WRITE(44,101) (PHI_new(I),I=1,mKP1)
        WRITE(44,101) ((X2_new(I,J),I=1,mIP1),J=1,mJP1)
        WRITE(44,101) ((Y2_new(I,J),I=1,mIP1),J=1,mJP1)
 101   format(5e16.7)
        close(44)
c
	   return
	   end
c
c
      subroutine chkdiv(bi,bj,bk,mi,mj,mk)
c
      parameter ( maxdiv= 3600 )
      dimension bi(mi+1,mj,mk),bj(mi,mj+1,mk),bk(mi,mj,mk+1)
      dimension div(maxdiv),idiv(maxdiv),jdiv(maxdiv),kdiv(maxdiv)
      dimension fb(maxdiv)
c
      do i=1,maxdiv
         div(i) = 0.0
         idiv(i) = 0
         jdiv(i) = 0
         kdiv(i) = 0
      enddo
c
      tstmax = 0.
      l = 1
      do k=1,mk
         do j=1,mj
            do i=1,mi
               fluxbar = abs(bi(i+1,j,k))+abs(bi(i,j,k))+
     $              abs(bj(i,j+1,k))+abs(bj(i,j,k))+
     $              abs(bk(i,j,k+1))+abs(bk(i,j,k))
               divtst = bi(i+1,j,k)-bi(i,j,k)+
     $              bj(i,j+1,k)-bj(i,j,k)+bk(i,j,k+1)-bk(i,j,k)
               divtst = abs(divtst)/(abs(fluxbar) +1.e-35)
               if ( divtst .gt. tstmax) then
                  tstmax = divtst
                  imax = i
                  jmax = j
                  kmax = k
               endif
         if ( l .le. maxdiv .and. divtst .ge. 1.e-10) then
            div(l) = divtst
            fb(l) = fluxbar
            idiv(l) = i
            jdiv(l) = j
            kdiv(l) = k
            l = l+1
         endif
            enddo
         enddo
      enddo
c
c  sort and go
c
      write (6,*) 'Maximum Divergence'
      write (6,*) imax,jmax,kmax,tstmax
      do i=1,l-1
         do j=1,l-2
            dum = div(j+1)
            if ( div(j) .lt. dum ) then
            idum = idiv(j+1)
            jdum = jdiv(j+1)
            kdum = kdiv(j+1)
            fdum = fb(j+1)
               div(j+1) = div(j)
               idiv(j+1) = idiv(j)
               jdiv(j+1) = jdiv(j)
               kdiv(j+1) = kdiv(j)
               fb(j+1) = fb(j)
               div(j) = dum
               idiv(j) = idum
               jdiv(j) = jdum
               kdiv(j) = kdum
               fb(j) = fdum
            endif
         enddo
       enddo
       do i=1,40
          write (6,911) idiv(i), jdiv(i), kdiv(i),div(i),fb(i)
 911      format (3i6,2(1pe15.4))
       enddo
      return
      end
c






