#ifdef LC_NOUNSC
#define RTIME rtime
#elif LC_UNSC
#define RTIME rtime_
#endif
/// Run time information (struct)
/**
 *  Struct to keep track of runtime information
 */
struct RTime { 
  float dt_old; 
  /// Timestep
  float dt; 
  /// Simulation time
  double time;  
  int ndump; 
  int nstop; 
  int lstep; 
  // How many timesteps between MHD+ION exchanges (Standard timestep IO)
  int nloop; 
  int nstart;
  /// Number of processors
  int number_of_processors;
  /// Process number
  int local_proc;
}; 
#define DT_OLD RTIME.dt_old 
#define DT RTIME.dt 
#define TIME RTIME.time 
#define NDUMP RTIME.ndump 
#define NSTOP RTIME.nstop 
#define LSTEP RTIME.lstep 
#define NLOOP RTIME.nloop 
#define NSTART RTIME.nstart 
