#include "Dipole.h"

float Dipole::bx(const float &x, const float &y, const float &z)
{
  const float rsq = x*x + y*y + z*z;
  const float r = sqrt(rsq);
  return ( -(constants::GEOQMU/rsq)*(3.0*x*z/rsq)/r );
}


float Dipole::by(const float &x, const float &y, const float &z)
{
  const float rsq = x*x + y*y + z*z;
  const float r = sqrt(rsq);

  return ( -(constants::GEOQMU/rsq)*(3.0*y*z/rsq)/r );
}


float Dipole::bz(const float &x, const float &y, const float &z)
{
  const float rsq = x*x + y*y + z*z;
  const float r = sqrt(rsq);
  
  return ( -(constants::GEOQMU/rsq)*((2.0-3.0*(x*x + y*y)/rsq)/r) );
}

