#ifndef __IONVARS_H__
#define __IONVARS_H__

#include <A++.h>

#include "IonGrid.h"

using namespace std;

/**
 * Used by startup generator to allocate & populate LFM Ionosphere variables.
 */
class IonVars{
public:
  IonVars(const int &n_j, const int &n_k);
  
private:
  IonGrid grid;
  
  floatArray rho0;
  floatArray c0;
  floatArray currentN, currentS;
  floatArray potentialN, potentialS;
  floatArray sigmaHallN, sigmaHallS;
  floatArray sigmaPedN, sigmaPedS;
  floatArray fluxN, fluxS;
  floatArray avgEnergyN, avgEnergyS;

  friend class LfmIon;
};
#endif
