#ifndef __LFMION_H__
#define __LFMION_H__

#include "DateTime.h"
#include "Io.h"
#include "Model.h"

#include "IonVars.h"

#include <map>
#include <string>

using namespace std;

/**
 * Interface between LFM Ionosphere variables and basic compute tasks,
 * such as I/O.
 */
class LfmIon : public Model
{
public:
  LfmIon(const int &ioType, IonVars *ion);

private:
  void readVariables(DateTime &ut);
  void writeVariables(const DateTime &ut);

  void setMeta(const DateTime &ut);

  IonVars *ion;
};

#endif
