#ifndef __LFMMHD_H__
#define __LFMMHD_H__

#include "constants.h"
#include "DateTime.h"
#include "Io.h"
#include "MhdVars.h"
#include "Model.h"

#include <iomanip>
#include <sstream>
#include <string>

using namespace std;

/**
 * Interface between LFM MHD variables and basic compute tasks, such as I/O.
 */
class LfmMhd : public Model
{
public:
  LfmMhd(const int &ioType, MhdVars *mhd);

private:
  void readVariables(DateTime &ut);
  void writeVariables(const DateTime &ut);

  void setMeta(const DateTime &ut);

  MhdVars *mhd;
};

#endif
