#ifndef __MHDVARS_H__
#define __MHDVARS_H__

#include "constants.h"

#include <A++.h>

#include "Dipole.h"
#include "MhdGrid.h"
#include "Integration.h"

using namespace std;

/**
 * Used by startup generator to allocate & populate LFM MHD variables.
 */
class MhdVars{
public:
  MhdVars(const int &n_i, const int &n_j, const int &n_k);
  
private:
  MhdGrid grid;
    
  floatArray rho;
  floatArray vx, vy, vz;
  floatArray c;
  floatArray bx, by, bz;
  floatArray bi, bj, bk;
  floatArray ei, ej, ek;  

  /// Fill in bi, bj, bk:
  void setMagneticFlux();

  // FIXME:  Does this belong in some sort of Dipole object?
  void getVectorPotentials(floatArray &Ai, floatArray &Aj, floatArray &Ak);
  void integrateVectorPotentials(floatArray &Ai, floatArray &Aj, floatArray &Ak);
  void setVectorPotentialBoundary(floatArray &Ai, floatArray &Aj, floatArray &Ak);
  
  void computeMagneticFlux(const floatArray &Ai, const floatArray &Aj, const floatArray &Ak);

  // Fill in bx, by, bz:
  void setMagneticField();

  friend class LfmMhd;
};
#endif
