#include "Params.h"

Params::Params()
{
  isUtio=true;
  // default to single res
  ni=53;
  nj=24;
  nk=32;

  convertFromOpenMP=false;

  basename=string("ChangeMe");
  ymdhms = DateTime(-999.9); // -999.9 is the default MJD used for TimeStep I/O.
  step0 = 0;
  runIdentifier=string("Description of run");
}

/**
 * This input function does no error checking.  It is extremely easy
 * for a user to shoot themselves in the foot!  We offload all
 * error-checking to the scripts used to configure & execute the
 * model.
 */
void Params::input()
{
  cout << "LFM Startup file Generator" << endl;
  cout << "Note: There is no error checking on user input. Users: try the script generator.  Develoeprs: be careful!" << endl;

  cout << "Resolution (ni nj nk) " << endl;
  cin >> ni >> nj >> nk;

  string boolStr;
  cout << "Input OpenMP HDF file? (T/F) " << endl;
  cin >> boolStr;
  convertFromOpenMP = str2bool(boolStr);

  cout << "Basename for this run?" << endl;
  cin >> basename;
  
  cout << "Use standard UTIO filenames? (T/F)" << endl;
  cin >> boolStr;
  isUtio = str2bool(boolStr);

  if (isUtio){
    cout << "Starting Y M D H M S" << endl;
    int year,month,day,hour,minute,second;
    cin >> year >> month >> day >> hour >> minute >> second;
    ymdhms = DateTime(year,month,day,hour,minute,second);
  }
  else{
    cout << "Timestep Number" << endl;
    cin >> step0;
  }

  cout << "Number of seconds for spinup (typically 3000.0 for 50 minutes)" << endl;
  cin >> tzero;

  cout << "Descriptive run name to be stored as meta data in file?" << endl;
  /* notes:  
   *    1. cin will break on first whitespace
   *    2. std::getline(...) is part of glibc & is unavailable on AIX
   *    3. ... guess we're using fgets!  Note we must
   *       std::cin.ignore() the previous newline character or fgets
   *       assumes the input is "\n".
   */
  char rId[2048];
  cin.ignore(); // ignore the previous newline from std::cin.
  fgets(rId, 2048, stdin); // get the whole string (including whitespace)
  runIdentifier = rId;
}

bool Params::str2bool(const string &inStr)
{
  string ins = inStr;

  transform(inStr.begin(), inStr.end(), ins.begin(), ::toupper);
  if ( (ins.compare("T") == 0) ||
       (ins.compare("TRUE") == 0) ||
       (ins.compare("1") == 0) )
    return true;
  else
    return false;
}
