#ifdef LC_NOUNSC
#define WIND wind
#elif LC_UNSC
#define WIND wind_
#endif

/// NTABLE must match the value stored in boundx.inc
#define NTABLE 40000

/// Struct that gives C++ access to FORTRAN common block "WIND" defined in boundx.inc
/**
 *  @note - The corresponding FORTRAN common block "WIND" is defined
 *          in "boundx.inc" ... NOT "swind.inc" (which doesn't even exist!)
 */
struct WIND { 
  int MJIN;
  int MJINP1;
  int mjinp2;
  int MJWALL;
  int MJWP1;
  int mjwp2;
  float tzero;
  float vfx;
  float vfy;
  float vfz;
  float rho_0;
  float vx_0;
  float vy_0;
  float vz_0;
  float c_0;
  float bx_0;
  float by_0;
  float bz_0;
  float rho_1;
  float vx_1;
  float vy_1;
  float vz_1;
  float c_1;
  float bx_1;
  float by_1;
  float bz_1;
  float tilt_angle;
  int itable;
  int index_now;
  float deltaT;
  float ut0;
  int Njp[NTABLE];
  float Vjx[NTABLE];
  float Vjy[NTABLE];
  float Vjz[NTABLE];
  float UT[NTABLE];
  float Cs[NTABLE];
  float BjX[NTABLE];
  float BjY[NTABLE];
  float BjZ[NTABLE];
  float BjT[NTABLE];
  float Zangle[NTABLE];
  float by_coef;
  float bz_coef;
  float bx_zero;
  bool table;
  bool SM;
  bool SWFROMFILE;
};

#define MJIN	   WIND.MJIN
#define MJINP1	   WIND.MJINP1
#define MJINP2	   WIND.mjinp2
#define MJWALL	   WIND.MJWALL
#define MJWP1	   WIND.MJWP1
#define MJWP2	   WIND.mjwp2
#define TZERO	   WIND.tzero
#define VFX	   WIND.vfx
#define VFY	   WIND.vfy
#define VFZ	   WIND.vfz
#define RHO_0	   WIND.rho_0
#define VX_0	   WIND.vx_0
#define VY_0	   WIND.vy_0
#define VZ_0	   WIND.vz_0
#define C_0	   WIND.c_0
#define BX_0	   WIND.bx_0
#define BY_0	   WIND.by_0
#define BZ_0	   WIND.bz_0
#define RHO_1	   WIND.rho_1
#define VX_1	   WIND.vx_1
#define VY_1	   WIND.vy_1
#define VZ_1	   WIND.vz_1
#define C_1	   WIND.c_1
#define BX_1	   WIND.bx_1
#define BY_1	   WIND.by_1
#define BZ_1	   WIND.bz_1
#define TILT_ANGLE WIND.tilt_angle
#define ITABLE	   WIND.itable
#define INDEX_NOW  WIND.index_now
#define DELTAT	   WIND.deltaT
#define UT0	   WIND.ut0
#define NJP	   WIND.Njp
#define VJX	   WIND.Vjx
#define VJY	   WIND.Vjy
#define VJZ	   WIND.Vjz
#define UT	   WIND.UT
#define CS	   WIND.Cs
#define BJX	   WIND.BjX
#define BJY	   WIND.BjY
#define BJZ	   WIND.BjZ
#define BJT	   WIND.BjT
#define ZANGLE	   WIND.Zangle
#define BY_COEF	   WIND.by_coef
#define BZ_COEF	   WIND.bz_coef
#define BX_ZERO	   WIND.bx_zero
#define TABLE	   WIND.table
#define SM	   WIND.SM
#define SWFROMFILE WIND.SWFROMFILE
