// Custom
#include <Average.h>

// 3rd-party
#include <A++.h>

// Standard
#include <vector>

using namespace std;

int main(int argc, char **argv)
{
  cout << "Command-line arguments:" << endl;
  for(int i=0; i < argc; i++){
    cout << "\targv[" << i << "]: " << argv[i] << endl;
  }
  cout << endl;

  //int num_procs = atoi(argv[1]);  
  int num_procs = 8;

  cout << "num_procs is " << num_procs << endl;
  Optimization_Manager::Initialize_Virtual_Machine("testAveragePpp",num_procs, argc, argv);
  vector <int> variables;

  variables.insert( variables.end(), AverageVariables::BX ); 
  variables.insert( variables.end(), AverageVariables::BY );
  variables.insert( variables.end(), AverageVariables::BZ );

  Partitioning_Type mhdGhost(num_procs);
  mhdGhost.partitionAlongAxis(0, TRUE, 8);
  mhdGhost.partitionAlongAxis(1, TRUE, 8);
  mhdGhost.partitionAlongAxis(2, FALSE, 8);

  Average<floatArray> accumulate(54, 25, 33, mhdGhost, variables);

  accumulate.setDeltaTime(0.5);

  floatArray var(54,25,33);
  var.partition(mhdGhost);
  var.setBase(1);
  
  var = 1.0;
  accumulate.increment(var, AverageVariables::BX);
  accumulate.increment(var, AverageVariables::BY);
  accumulate.increment(var, AverageVariables::BZ);

  var = 2.0;
  accumulate.increment(var, AverageVariables::BX);
  accumulate.increment(var, AverageVariables::BY);
  accumulate.increment(var, AverageVariables::BZ);

  accumulate.reset();

  Optimization_Manager::Exit_Virtual_Machine();
}
