#!/bin/csh
#
# Check the RMS error of all the variables in ARGV[0] and ARGV[1] for
# LFM "ion" data files.
#

if ($#argv != 2) then
    echo "Usage: "
    echo "   $0 <LFM_ION_HDF_FILE 0> <LFM_ION_HDF_FILE 1>"
    echo "   Make sure that "
    echo "     1:  data values are valid"
    echo "     2:  the RMS error is within a valid threshold"
    exit 0
endif

set base_file = $1
set test_file = $2

./RMSerror 1 $base_file $test_file x2ion 1
./RMSerror 1 $base_file $test_file y2ion 1
./RMSerror 1 $base_file $test_file x_interp 1
./RMSerror 1 $base_file $test_file y_interp 1
./RMSerror 1 $base_file $test_file rho0 1
./RMSerror 1 $base_file $test_file c0 1
./RMSerror 1 $base_file $test_file curnorth 1
./RMSerror 1 $base_file $test_file potnorth 1
./RMSerror 1 $base_file $test_file SigmaH_north 1
./RMSerror 1 $base_file $test_file SigmaP_north 1
./RMSerror 1 $base_file $test_file fluxnorth 1
./RMSerror 1 $base_file $test_file avE_north 1
./RMSerror 1 $base_file $test_file cursouth 1
./RMSerror 1 $base_file $test_file potsouth 1
./RMSerror 1 $base_file $test_file SigmaH_south 1
./RMSerror 1 $base_file $test_file SigmaP_south 1
./RMSerror 1 $base_file $test_file fluxsouth 1
./RMSerror 1 $base_file $test_file avE_south 1
