#!/bin/csh
#
# Check the RMS error of all the variables in ARGV[0] and ARGV[1] for
# LFM "mhd" data files.
#

if ($#argv != 2) then
    echo "Usage: "
    echo "   $0 <LFM_MHD_HDF_FILE 0> <LFM_MHD_HDF_FILE 1>"
    echo "   Make sure that "
    echo "     1:  data values are valid"
    echo "     2:  the RMS error is within a valid threshold"
    exit 0
endif

set base_file = $1
set test_file = $2

./RMSerror 1 $base_file $test_file X_grid 1
./RMSerror 1 $base_file $test_file Y_grid 1
./RMSerror 1 $base_file $test_file Z_grid 1
./RMSerror 1 $base_file $test_file rho_ 1
./RMSerror 1 $base_file $test_file vx_ 1
./RMSerror 1 $base_file $test_file vy_ 1
./RMSerror 1 $base_file $test_file vz_ 1
./RMSerror 1 $base_file $test_file c_ 1
./RMSerror 1 $base_file $test_file bx_ 1
./RMSerror 1 $base_file $test_file by_ 1
./RMSerror 1 $base_file $test_file bz_ 1
./RMSerror 1 $base_file $test_file bi_ 1
./RMSerror 1 $base_file $test_file bj_ 1
./RMSerror 1 $base_file $test_file bk_ 1
./RMSerror 1 $base_file $test_file ei_ 1
./RMSerror 1 $base_file $test_file ej_ 1
./RMSerror 1 $base_file $test_file ek_ 1
