#!/bin/perl

############
# check_dt #
############################################################################
# parameters:
#    path  : path to MSPHERE.info file
#    value : timestep dt to compare against
############################################################################
sub check_dt {
    $num = scalar(@_);
    if ($num != 2) {
       die "Usage: check_dt(<LOGFILE>, <LIMIT>)\n";
    }
    
    if ($_[2]){
       print "Confirming DT less than $ARGV[1] in $ARGV[0] \n";
    }
    # open(SHELL,"$_[0]") || die "Unable to open $_[0] \n";
    open(SHELL, "$_[0]") || return -1;
    
    $count = 0;
    while(<SHELL>){
    if (/Loop #/){
	if (/DT: ([-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?)/) {$dt = $1}
	if ($dt > $_[1]) {$count++}
    }
    }
    if ($_[2]) {
       print "$count violations occurred.\n";
       return 999;
    } else {
       return 0;
    }
}

############################################################################

#
# Search $ARGV[0]/$ARGV[1] file for values of dt > $ARGV[2]
#
$num = scalar(@ARGV);
if ($num != 3) {
    die "Usage: check_dt.pl <LOGFILE_DIR> <LOGFILE_NAME> <LIMIT> \n";
}

open RESULT_FILE, ">".$ARGV[0]."/RESULT";
if ( &check_dt($ARGV[0]."/".$ARGV[1], $ARGV[2]) == 0){
    print RESULT_FILE "SUCCESS\n";
    print "MSPHERE-".$ARGV[0]." dt test passed!";
} elsif (&check_dt($ARGV[0]."/".$ARGV[1], $ARGV[2]) == -1){
    if (-e $ARGV[0]."/MSPHERE.script"){
	print RESULT_FILE "PENDING\n";
	print "*** MSPHERE-".$ARGV[0]." dt test pending";
    } else{
	print RESULT_FILE "FAIL\n";
	print "MSPHERE-".$ARGV[0]." dt test failed!";
    }
} else {
    print RESULT_FILE "FAIL\n";
    print "MSPHERE-".$ARGV[0]." dt test failed!";
}
close RESULT_FILE;

