#ifndef IM_GRIDS_H
#define IM_GRIDS_H

#include "Overture.h"

class IM_Grids {
public:
  IM_Grids();
protected:

  void setupIMgrid_2d();

  /**\name Inner Magnetosphere (i.e. RCM) Grid parameters */
  //@{
  int nLat; //!< Number of grid points in the latitudinal direction
  int nLon; //!< Number of grid points in the longitudinal direction. 

  float R_i; //!< Height of Ionosphere

  floatArray colatitudes;  //!< co-latitude from pole (SM, radians) 
  floatArray longitudes; //!< 0 at noon (SM, radians) 

  // Note the 2d IM grid must be a realArray (defaults to double) to
  // use Overture's interpolatePoints function.
  realArray IMgrid_2d;   //!< Cartesian gridpoints corresponding to lat/lon spherical grid.
  //@}

private:

};

#endif
