#ifndef IM_INTERFACE_H
#define IM_INTERFACE_H

#include "functions.h"
#include "IM_Grids.h"


#include "InterComm.h"
#include "interpolatePoints.h"

class IM_Interface : public IM_Grids{
public:
  IM_Interface(IC_XJD *XJD);
  virtual ~IM_Interface() {};

  virtual void Initialize() = 0;

  virtual void Export(const realCompositeGridFunction &mixSolverFunctions) = 0;
  virtual void Import() = 0;

protected:

  void dimensionData();
  void prepareExport(const realCompositeGridFunction &mixSolverFunctions);
  void processImport();

  IC_XJD *xjd;

  /**\name MIX Export Array to RCM */
  //@{
  floatArray pot; //!< Potential 2-d (nLat, nLon) - on RCM grid 
  floatArray sigma_p; //!< Pedersen conductance 
  floatArray sigma_h; //!< Hall conductance 
  //@}

  /**\name MIX Import Arrays from RCM - (nLat,nLon) - on RCM grid*/
  //@{
  floatArray avgEng;   //!< Average Energ
  floatArray engFlux;  //!< Energy Flux
  floatArray j_fac; //!< Total FAC density
  //@}

private:

  void interpMixToIm(const realCompositeGridFunction mixSolverFunctions, const int &index, floatArray &dest);

};

#endif
