#ifndef ITM_IC_INTERFACE_H
#define ITM_IC_INTERFACE_H

/**
 * \file ITM_IC_Interface.h
 * \brief ITM_IC_Interface class declaration
 * \class ITM_IC_Interface
 * 
 * \brief Contains functions for communications with the ITM
 *
 * \author Slava Merkin (vgm at bu.edu)
 * \since 06-2007
 *
 * This class contains functions and variables that establish
 * communication with the ITM model.
*/

#include "ITM_Interface.h"
#include "Check_IC_Status.h"

#include "InterComm.h"

class ITM_IC_Interface : public ITM_Interface {

 public:
  /**\brief Class constructor*/
  ITM_IC_Interface(Params *, IC_XJD *);

  /**\brief Class constructor*/
  virtual ~ITM_IC_Interface();

  /**\brief Import data to ITM*/
  void Import(realCompositeGridFunction &);

  /**\brief Export data from ITM*/
  void Export(const intArray &, realCompositeGridFunction &);

 private:
  /**\name InterComm variables */
  int ic_err;
  IC_Desc* desc;
  IC_Region* regions[1];
};

#endif
