#ifndef CONST_H
#define CONST_H

/*!\file const.h
  \brief Global constant definitions
*/

#include <math.h>
#include "Overture.h"

static const Range all;

static const int STRLEN=256; //!< The default length of character strings

static const real RION= 6.5e8; //!< The radius of the ionosphere in cm

static const real PI= 4.*atan(1.);


/**\name Physical variables and conversion factors */

static const real mp= 1.673e-24; //!< Proton rest mass in g

static const real heFrac= 1.16; //!< Accounts for 4% helium
    
static const real kev2erg= 1.602e-9; //!< 1 keV = 1.602e-9 ergs

static const real erg2kev= 1.0/kev2erg ;  

static const real eCharge= 1.602e-19  ;  //!< Charge of electron


/**\name Boolean constants used when there is a need to loop over hemispheres */
static const bool NORTH = 1;
static const bool SOUTH = 0;
#endif
