#ifndef IONOSPHERE
#define IONOSPHERE

/**
 * \file ionosphere.h
 * \brief Main ionosphere header file
 *
 * \author Slava Merkin (vgm at bu.edu)
 * \since 2005
 */

#include "Overture.h"  
#ifndef OV_USE_DOUBLE
#error The MIX ionosphere requires double-precision Overture, however Overture does not appear to be compiled with double-precision.
#endif

// 3rd-party includes
#include "interpolatePoints.h"
#include "PlotStuff.h"
#include "DataPointMapping.h"
#include "Ogshow.h"
#include "InterComm.h"

// custom includes
#include "Params.h"
#include "functions.h"
#include "MHD_Interface.h"
#include "MHD_IC_Interface.h"
#include "MHD_FE_Interface.h"
#include "ITM_Interface.h"
#include "ITM_IC_Interface.h"
#include "ITM_FE_Interface.h"
#include "IM_Interface.h"
#include "IM_IC_Interface.h"
#include "Conductance.h"
#include "IO.h"
#include "Solver.h"

#include <sstream>

#endif // IONOSPHERE
