C
C NAME:
C   HMS_SOD
C PURPOSE:
C   Converts Time (Hr,Min,Sec) into Seconds of Day and v.v.
C CATEGORY
C   Time keeping
C CALLING SEQUENCE
C   	SUBROUTINE hms_sod(id,ihr,imin,rsec,rsod)
C
C INPUTS
C   ID		INTEGER		ID=0 Time (Hr,Min,Sec) ---> Second of Day
C				ID=1 Second of Day ---> Time (Hr,Min,Sec)
C
C   ID=0
C     ihr	INTEGER 	Hour of Day
C     imin	INTEGER		Minute of Hour
C     rsec      REAL*8		Second of Minute
C
C   ID=1
C     rsod	REAL*8		Second of Day
C
C OUTPUTS
C   ID=0
C     rsod	REAL*8		Seconds of Day
C
C   ID=1
C     ihr       INTEGER         Hour of Day
C     imin      INTEGER         Minute of Hour
C     rsec      REAL*8          Second of Minute
C
    	SUBROUTINE hms_sod(id,ihr,imin,rsec,rsod)

	INTEGER id
	INTEGER ihr
	INTEGER iMin
	REAL*8 rSec
	REAL*8 rSoD

        REAL*8 rSecInHr,rSecInMin,rtmp

        rSecInHr = 3600.0
        rSecInMin = 60.0

	IF (0 .EQ. id) THEN
          rsod = ihr*rSecInHr+imin*rSecInMin+rsec
        ENDIF
        IF (1 .EQ. id) THEN
	  ihr = INT(rsod/rSecInHr)
          imin = INT((rsod-rSecInHr*ihr)/rSecInMin)
          rtmp = rsod-rsecinhr*ihr-rSecInMin*imin
          rsec = rtmp
        ENDIF

	END


