from Models.Model import Model

import os
import unittest

class NewModelTemplate(Model):
    """ Template for [NEW-MODEL] model input type.  See NewModelTemplate.yml for variable definitions. """

    def __init__(self):
        """
        Instantiate model/parameter type
        """
        #filename = os.path.join(os.path.dirname(__file__), "NewModelTemplate.yml")
        #Model.__init__(self, filename)

    def get_model_setup(self, model_name, has_spinup, run_identifier, start_datetime):
        """
        Returns:
          string shScript: Shell script that configures this model.
          string instructions: Specific instructions or notes on running this model.
        """
        return ''

    def get_iteration_setup(self, model_name, iteration):
        """
        Setup environment to run a model, ends with newline when not empty
        """
        return ""
    
    def get_iteration_teardown(self, model_name, iteration):
        """
        Teardown environment to run a model, ends with newline when not empty
        """        
        return ""

    def get_run_instructions(self, model_name, iteration):
        """
        Get the executable, inputs & outputs needed to run the model.

        For example usage, see 'test_get_run_instructions'.
        
        Note: Required function (standardized parameters & return variables)        

        Returns:
          boolean:  True when parallel
          executable:  Name of executable to run
          flags:  any command-line arguments
          stdin:  where to redirect stdin input from
          stdout_and_stderr:  Where to redirect stdout/stderr to?
        """
        None

    def get_input_file(self):
        """
        Get contents of [] input parameter file

        Returns:
          str_script: String of job script

        Note: Required function (standardized parameters & return variables)
        """
        None

    def set_shared_parameters(self, shared_model, env=None):
        """
        Note: Required function (standardized parameters & return variables)
        """        
        None

    def set_time_information(self, start_datetime, stop_datetime):
        """
        Take care of any special behavior for start/stop times for a run.
        
        Parameters:
          start_datetime: datetime object specifying the starting
            year-month-day-hour-minute-second for this segment.
          stop_datetime:  Unused.  Stop time determined by LFM kill signal.

        Note: Required function (standardized parameters & return variables)
        """
        None

class TestNewModelTemplate(unittest.TestCase):
    def setUp(self):
        self.params = NewModeltemplate()

    def test_truth(self):
        self.assertEqual(True, True)
