"""
Coupled and stand-alone models must be defined in 'models.yml'.

To add additional models, you must:
  * Define it in 'models.yml'
  * Create [MODEL-NAME].yml defining parameters
  * Create [MODEL-NAME].py, including a [MODEL-NAME] class derived from Model.  See LFM.py for an example.
  * Add import statement to Models/__init__.py

See README for more details.
"""

#FIXME:  UTIO support only--no timestep support

from LFM import LFM, TestLFM
from MIX import MIX, TestMIX
from RCM import RCM, TestRCM
from Shared import Shared, TestShared
from TIEGCM import TIEGCM, TestTIEGCM
from XJD import XJD, TestXJD

# Adding a new model?  Make sure to import its class & tests!

from helpers import getModelCoupling
from helpers import getSegmentTimes, TestGetSegmentTimes
import inputs
