"""Release data for the MakeItSo project
$Id: Release.py 2005 2012-06-13 19:50:53Z schmitt $
"""
#*****************************************************************************
# Copyright (C) 2009-2012 Peter Schmitt <schmitt@ucar.edu>
#
# Distributed under the terms of a to-be-determined license
#*****************************************************************************

name = "makeItSo"

revision = "2004"

version = "2.1.5.svn.r" + revision.rstrip("M")

description = "A script & input file generator for numerical models."

verboseDebug = False

long_description = \
"""
MakeItSo simplifies the process of generating sets of scripts and
input files necessary to run complex numerical models on a variety of
compute environments.

Main features:

* Prompts the user for the minimal set of input parameters to run a
  model.  User input works in several ways:

  - Input from a shell terminal (stdin)

  - From a text configuration file.  These configuration files are
    automatically generated each time makeItSo is run.  Look for a file
    ending with "_makeItSo.config" in your output run directory.

  - Web Interface (Coming soon!)

* Generates model input files for a single model or a collection of
  coupled models

* Generates shell scripts on a variety of computer systems, taking
  into account parallel job queues

* Is highly extensible

  - Easily add new models (stand-alone or coupled); see Models/README
    for details.

  - Easily supports new compute environments & queueing systems; see
    Environments/README for details.
"""

license = "TBD"

authors = {"Peter" : ("Peter Schmitt", "schmitt@ucar.edu")}

url = "http://www.hao.ucar.edu"

download_url = "https://proxy.subversion.ucar.edu/cism_MODELS/trunk/LTR-para/misc/python"

platforms = ["Linux","Mac OSX"]
