import os, sys
import pylab

norm = 2
path = "March20-April19[f107_100][hp_6][CPCP_20]"
#path = "March20-April19[f107_70][hp_6][CPCP_20]"
#path = "Nov11-Dec20[f107_250][hp_6][CPCP_20]"
#path = "Nov11-Dec20[f107_70][hp_120][CPCP_200]"
#path = "Nov11-Dec20[f107_70][hp_6][CPCP_20]"


variables = [ "TN", "UN", "VN", "O2", "O1", "N4S", "NO", "OP", "N2D", "TI", "TE", "NE", "O2P", "OMEGA",
              "Z", "POTEN", "TN_NM", "UN_NM", "VN_NM", "O2_NM", "O1_NM", "N4S_NM", "NO_NM", "OP_NM"   ]

#----------------------------------------------------------------------------------------------------------------#

def compare_variable(prev, prev_step, next, next_step, variable):

    command = "./CalculateNorm " + "2 " + str(norm) + " "
    command = command + "\""+path+"\"/"+prev_file + " " + str(prev_step) + " "
    command = command + "\""+path+"\"/"+next_file + " " + str(next_hour) + " " + variable

    print command

    commandResults = os.popen(command)
    aline = commandResults.next()
    result = float(aline)
    commandResults.close()
    return result


def getFiles():
    """
    FIXME:  Kludge to check for multiple timesteps in a file.
    """
    files = []
    
    lines = os.listdir(os.path.join(path,""))
    
    for aline in lines:
        filename = aline.strip()
        if (filename.count(".nc") >= 1):
            print os.path.join(path, filename), os.path.getsize(os.path.join(path, filename))
            # 349399000 is approx size of a "full" file.
            if (os.path.getsize(os.path.join(path, filename)) >= 349399000):
                files.append(filename)

    files.sort()
    return files

#----------------------------------------------------------------------------------------------------------------#


if __name__ == '__main__':
    ERR_TN = []
    ERR_NE = []
    min_TN =  1.0e80 
    max_TN = -1.0e80
    min_NE =  1.0e80
    max_NE = -1.0e80
    time = []

    files = getFiles()
    for fIndex in range(len(files)-1):

        prev_file = files[fIndex]
        prev_hour = str(0)
    
        for hour in range(0,24,6):
            next_file = files[fIndex+1]
            next_hour = str(hour)
            prev_hour = str(hour)
            
            ERR = compare_variable(prev_file,prev_hour,   next_file, next_hour,  "TN")
            min_TN = ERR if (abs(ERR) < min_TN) else min_TN
            max_TN = ERR if (abs(ERR) > max_TN) else max_TN
            ERR_TN.append( ERR )
            ERR = compare_variable(prev_file,prev_hour,   next_file, next_hour,  "NE")
            min_NE = ERR if (abs(ERR) < min_NE) else min_NE
            max_NE = ERR if (abs(ERR) > max_NE) else max_NE
            ERR_NE.append( ERR )
            
            time.append(fIndex+hour/24.0)
            print ERR_TN[len(ERR_TN)-1], ERR_NE[len(ERR_NE)-1],  fIndex+hour/24.0
        
    # Normalize max error
    if norm == 1:
        for i in range(len(ERR_TN)):
            ERR_TN[i] = ERR_TN[i] / max_TN
            ERR_NE[i] = ERR_NE[i] / max_NE

    pylab.figure()
    pylab.plot(time, ERR_TN)
    pylab.plot(time, ERR_NE,'r')
    pylab.title("TIEGCM Diurnal Tide 24-h differences")
    pylab.legend(["TN (" + str(min_TN) + ", " + str(max_TN) + ")",
                  "NE (" + str(min_NE) + ", " + str(max_NE) + ")"], loc='best')
    pylab.xlabel("Day")
    if norm == 1:
        pylab.ylabel("Max Difference (normalized)")
        filename = path + "-max.png"
    elif norm == 2:
        pylab.ylabel("RMS difference")
        filename = path + "-rms.png"

    pylab.savefig(filename)
    pylab.show()
