
      program hello

      real*8 export(10)
      real*8 import(10)

      integer xjd, status
      ! IC_Create_bdecomp_desc:
      integer blocks(1,2,1), tasks(1), desc
      ! IC_Create_block_region:
      integer lower(1), upper(1), stride(1), region

      write(6,*) "Hello parallel worlds!"
      
      do i=1,10
         export(i) = i*2.0-1.0
      end do

      call IC_Initialize("helloF90", 0, "hello.xjd", xjd, status)
      if ( status .ne. 0 ) then
         write(*,*) "Error in hello.f90::IC_Initialize"
         write(*,"(a (I5))") "Status code: ", status
      end if

      tasks(1) = 0
      blocks(1,1,1) = 1
      blocks(1,2,1) = 10
      call IC_Create_bdecomp_desc(
     $     1, blocks, tasks, 1, desc, 0)
      !  IC_ROW_MAJOR = 0            ^^^
      !  IC_COLUMN_MAJOR  = 1        ^^^

      lower(1) = 1
      upper(1) = 10
      stride(1) = 1
      call IC_Create_block_region(1, lower, upper, stride, region)

      call IC_Register_region(
     $     xjd, region, 1, "odd", desc, export, status)
      call IC_Register_region(
     $     xjd, region, 1, "even", desc, import, status)

      call IC_Commit_region(xjd, status)

      call IC_Import(xjd, "even", status)
      call IC_Export(xjd, "odd", status)

      ! print contents of arrays
      write(6,"(a (10F5.1))") "Export: ", export
      write(6,"(a (10F5.1))") "Import: ", import

      call IC_Finalize(xjd, status)
      
      if ( status .ne. 0 ) then
         write(*,*) "Error in hello.f90::IC_Finalize"
         write(*,"(a (I5))") "Status code: ", status
      end if

      end
