
program hello

  real, allocatable :: serialArray(:)
  real, allocatable :: parallelArray(:)

  character *100 argv
  integer arrayLength, pArrayLength  

  integer xjd, status
  ! IC_Create_bdecomp_desc:
  integer blocks(1,2,1), tasks(1), desc
  ! IC_Create_block_region:
  integer lower(1), upper(1), stride(1), region

  write(6,*) "Hello world!"

  call getarg(1, argv)      
  read(argv, '(i2)') arrayLength ! string to int type conversion

  ! Startup InterComm
  call IC_Initialize("serialProgram", 0, "hello.xjd", xjd, status)
  if ( status .ne. 0 ) then
     write(*,*) "Error in hello.f90::IC_Initialize"
     write(*,"(a (I5))") "Status code: ", status
  end if

  ! Check dims
  call IC_bcast_local(xjd, "serialSize", arrayLength, 1, status)
  write(*,*) "IC_Register_region status is ", status
  call IC_Recv_local(xjd, "parallelSize", pArrayLength, 1, status)
  write(*,*) "IC_Register_region status is ", status
  write(*,*) "serial size: ", arrayLength, "Parallel size: ", pArrayLength

  ! Initialize the arrays
  allocate ( serialArray( arrayLength) )
  allocate ( parallelArray( arrayLength) )

  tasks(1) = 0
  blocks(1,1,1) = 1
  blocks(1,2,1) = arrayLength

  lower(1) = 1
  upper(1) = arrayLength
  stride(1) = 1

  call IC_Create_bdecomp_desc(1, blocks, tasks, 1, desc, 1)
  call IC_Create_block_region(1, lower, upper, stride, region)
  call IC_Register_region(xjd, region, 1, "parallel_to_serial", desc, parallelArray, status)
  write(*,*) "IC_Register_region status is ", status
  call IC_Register_region(xjd, region, 1, "serial_to_parallel", desc, serialArray, status)
  write(*,*) "IC_Register_region status is ", status

  call IC_commit_region(xjd, status)
  write(*,*) "IC_commit_region status is ", status

  ! Do some work...
  do i=1,arrayLength
     serialArray(i) = arrayLength-i+1
  end do

  call IC_Import(xjd, "parallel_to_serial", status)
  write(*,*) "IC_Import status is ", status

  call IC_Export(xjd, "serial_to_parallel", status)
  write(*,*) "IC_Export status is ", status

  ! print contents of arrays
  write(*,*) "Serial: ", serialArray
  write(*,*) "Parallel: ", parallelArray

  ! Cleeanup
  call IC_Finalize(xjd, status)

  if ( status .ne. 0 ) then
     write(*,*) "Error in hello.f90::IC_Finalize"
     write(*,"(a (I5))") "Status code: ", status
  end if

end program hello
